/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august september 1998.
 * This is total free software.
 *-------------------------------------
 * the instrument editor - editing handling
 */

#include "sub_instrument.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <string.h>
#include <stdio.h>

#include "xm.h"
#include "interface.h"
#include "screen.h"

/* those fun are in instrument.c, don't want to make a .h, they are private to instrument.c and sub_instrument.c
 * (2 files only because of their size)
 */
extern void draw_volume_envelope(INTERFACE *,instrument *);
extern void draw_panning_envelope(INTERFACE *,instrument *);
extern void draw_nb_points_volume(INTERFACE *,instrument *);
extern void draw_sustain_point_volume(INTERFACE *,instrument *);
extern void draw_loop_start_volume(INTERFACE *,instrument *);
extern void draw_loop_end_volume(INTERFACE *,instrument *);
extern void draw_use_volume(INTERFACE *,instrument *);
extern void draw_nb_points_panning(INTERFACE *,instrument *);
extern void draw_sustain_point_panning(INTERFACE *,instrument *);
extern void draw_loop_start_panning(INTERFACE *,instrument *);
extern void draw_loop_end_panning(INTERFACE *,instrument *);
extern void draw_use_panning(INTERFACE *,instrument *);
extern void draw_fadeout(INTERFACE *,instrument *);
extern void draw_vib_type(INTERFACE *,instrument *);
extern void draw_vib_speed(INTERFACE *,instrument *);
extern void draw_vib_sweep(INTERFACE *,instrument *);
extern void draw_vib_depth(INTERFACE *,instrument *);
extern void draw_keyboard(INTERFACE *,instrument *);

void redraw_volume_envelope(INTERFACE *i,instrument *inst)
{
  draw_volume_envelope(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, 8+12-1, 20+3-3, 325+1+1, 65*2+2+3,
	    8+12-1, 20+3-3);
}

void draw_volume_cur_pos(INTERFACE *i, instrument *inst)
{
  char s[15];
  if (!inst->nb_volume_points)
    return;
  draw_box(i->X_ecran, inst->pixmap, i->context, 360, 160, 6*6+4, 12, LIGHTBLUE);
  sprintf(s, "%3d:%2d", inst->volume_envelop[inst->cur_pos_0][0], inst->volume_envelop[inst->cur_pos_0][1]);
  draw_string(i->X_ecran, inst->pixmap, i->context, 360+2, 160+10, s, i->little, BLUE);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, 360, 160, 6*6+4, 12, 360, 160);
}

void clear_volume_cur_pos(INTERFACE *i, instrument *inst)
{
  draw_box(i->X_ecran, inst->pixmap, i->context, 360, 160, 6*6+4, 12, BLACK);
  draw_box(i->X_ecran, inst->window, i->context, 360, 160, 6*6+4, 12, BLACK);
}

void redraw_panning_envelope(INTERFACE *i,instrument *inst)
{
  draw_panning_envelope(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, 8+12-1, PINY+20+3-3, 325+1+1, 64*2+2+3,
	    8+12-1, PINY+20+3-3);
}

void draw_panning_cur_pos(INTERFACE *i, instrument *inst)
{
  char s[15];
  if (!inst->nb_panning_points)
    return;
  draw_box(i->X_ecran, inst->pixmap, i->context, 360, PINY+160, 6*6+4, 12, LIGHTBLUE);
  sprintf(s, "%3d:%2d", inst->panning_envelop[inst->cur_pos_3][0], inst->panning_envelop[inst->cur_pos_3][1]);
  draw_string(i->X_ecran, inst->pixmap, i->context, 360+2, PINY+160+10, s, i->little, BLUE);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, 360, PINY+160, 6*6+4, 12, 360, PINY+160);
}

void clear_panning_cur_pos(INTERFACE *i, instrument *inst)
{
  draw_box(i->X_ecran, inst->pixmap, i->context, 360, PINY+160, 6*6+4, 12, BLACK);
  draw_box(i->X_ecran, inst->window, i->context, 360, PINY+160, 6*6+4, 12, BLACK);
}

void redraw_nb_points_volume(INTERFACE *i,instrument *inst)
{
  draw_nb_points_volume(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, NIX+9+6*7+5+13+3, 5+1+4+4+8, 6*6-4-16, 12,
	    NIX+9+6*7+5+13+3, 5+1+4+4+8);
}

void redraw_sustain_point_volume(INTERFACE *i,instrument *inst)
{
  draw_sustain_point_volume(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, NIX+9+6*7+5+13+3, 5+1+4+4+13+3+13+6+8, 6*6-4-16, 12,
	    NIX+9+6*7+5+13+3, 5+1+4+4+13+3+13+6+8);
}

void redraw_loop_start_volume(INTERFACE *i,instrument *inst)
{
  draw_loop_start_volume(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, NIX+9+6*7+5+13+3, 5+1+4+4+(13+3+13+6)*2+8, 6*6-4-16, 12,
	    NIX+9+6*7+5+13+3, 5+1+4+4+(13+3+13+6)*2+8);
}

void redraw_loop_end_volume(INTERFACE *i,instrument *inst)
{
  draw_loop_end_volume(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, NIX+9+6*7+5+13+3, 5+1+4+4+(13+3+13+6)*3+8, 6*6-4-16, 12,
	    NIX+9+6*7+5+13+3, 5+1+4+4+(13+3+13+6)*3+8);
}

void redraw_use_volume(INTERFACE *i,instrument *inst)
{
  draw_use_volume(i, inst);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, 3*5+2*6, 65*2+8+21+3+2+4, 10, 10, LIGHTBLUE,
		     inst->volume_type & 1 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, 3*5+2*6+24*6, 65*2+8+21+3+2+4, 10, 10, LIGHTBLUE,
		     inst->volume_type & 2 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, 3*5+2*6+40*6, 65*2+8+21+3+2+4, 10, 10, LIGHTBLUE,
		     inst->volume_type & 4 ? DOWN_3D : UP_3D);
}

void redraw_nb_points_panning(INTERFACE *i,instrument *inst)
{
  draw_nb_points_panning(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, NIX+9+6*7+5+13+3, 5+PINY+1+4+4+8, 6*6-4-16, 12,
	    NIX+9+6*7+5+13+3, 5+PINY+1+4+4+8);
}

void redraw_sustain_point_panning(INTERFACE *i,instrument *inst)
{
  draw_sustain_point_panning(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, NIX+9+6*7+5+13+3, 5+PINY+1+4+4+13+3+13+6+8, 6*6-4-16, 12,
	    NIX+9+6*7+5+13+3, 5+PINY+1+4+4+13+3+13+6+8);
}

void redraw_loop_start_panning(INTERFACE *i,instrument *inst)
{
  draw_loop_start_panning(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, NIX+9+6*7+5+16, 5+PINY+9+(13+3+13+6)*2+8, 6*6-4-16, 12,
	    NIX+9+6*7+5+13+3, 5+PINY+1+4+4+(13+3+13+6)*2+8);
}

void redraw_loop_end_panning(INTERFACE *i,instrument *inst)
{
  draw_loop_end_panning(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, NIX+9+6*7+5+16, 5+PINY+9+(13+3+13+6)*3+8, 6*6-4-16, 12,
	    NIX+9+6*7+5+13+3, 5+PINY+1+4+4+(13+3+13+6)*3+8);
}


void redraw_use_panning(INTERFACE *i,instrument *inst)
{
  draw_use_panning(i, inst);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, 3*5+2*6-3, PINY-2+65*2+8+21+3+2+4, 10, 10, LIGHTBLUE,
		     inst->panning_type & 1 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, 3*5+2*6+24*6+3, PINY-2+65*2+8+21+3+2+4, 10, 10, LIGHTBLUE,
		     inst->panning_type & 2 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, 3*5+2*6+40*6+3, PINY-2+65*2+8+21+3+2+4, 10, 10, LIGHTBLUE,
		     inst->panning_type & 4 ? DOWN_3D : UP_3D);
}

void redraw_fadeout(INTERFACE *i,instrument *inst)
{
  draw_fadeout(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, VFX+9+6*7+5+13+3, 5+VFY+1+4+4+8, 7*6-4-16, 12,
	    VFX+9+6*7+5+13+3, 5+VFY+1+4+4+8);
}

void redraw_vib_type(INTERFACE *i,instrument *inst)
{
  draw_vib_type(i, inst);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, VFX+50, VFY+74, 10, 10, LIGHTBLUE,
		     inst->vibrato_type==0 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, VFX+50, VFY+74+20, 10, 10, LIGHTBLUE,
		     inst->vibrato_type==1 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, VFX+50, VFY+74+20*2, 10, 10, LIGHTBLUE,
		     inst->vibrato_type==2 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, inst->window, i->context, VFX+50, VFY+74+20*3, 10, 10, LIGHTBLUE,
		     inst->vibrato_type==3 ? DOWN_3D : UP_3D);
}

void redraw_vib_speed(INTERFACE *i,instrument *inst)
{
  draw_vib_speed(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, VFX+9+6*7+5+13+3, 5+VFY+1+4+4+(13+3+13+6)*4+8, 6*6-4-16, 12,
	    VFX+9+6*7+5+13+3, 5+VFY+1+4+4+(13+3+13+6)*4+8);
}

void redraw_vib_sweep(INTERFACE *i,instrument *inst)
{
  draw_vib_sweep(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, VFX+9+6*7+5+13+3, 5+VFY+1+4+4+(13+3+13+6)*5+8, 6*6-4-16, 12,
	    VFX+9+6*7+5+13+3, 5+VFY+1+4+4+(13+3+13+6)*5+8);
}

void redraw_vib_depth(INTERFACE *i,instrument *inst)
{
  draw_vib_depth(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, VFX+9+6*7+5+13+3, 5+VFY+1+4+4+(13+3+13+6)*6+8, 5*6-4-16, 12,
	    VFX+9+6*7+5+13+3, 5+VFY+1+4+4+(13+3+13+6)*6+8);
}

void draw_keyboard_cur_pos(INTERFACE *i, instrument *inst)
{
  char s[25];
  draw_box(i->X_ecran, inst->pixmap, i->context, 380, PINY+160, 18*6+4, 12, LIGHTBLUE);
  sprintf(s, "Current note : %s%d", name_note[inst->cur_pos_7%12], inst->cur_pos_7/12);
  draw_string(i->X_ecran, inst->pixmap, i->context, 380+2, PINY+160+10, s, i->little, BLUE);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, 380, PINY+160, 18*6+4, 12, 380, PINY+160);
}

void clear_keyboard_cur_pos(INTERFACE *i, instrument *inst)
{
  draw_box(i->X_ecran, inst->pixmap, i->context, 380, PINY+160, 18*6+4, 12, BLACK);
  draw_box(i->X_ecran, inst->window, i->context, 380, PINY+160, 18*6+4, 12, BLACK);
}

void redraw_keyboard(INTERFACE *i,instrument *inst)
{
  draw_keyboard(i, inst);
  XCopyArea(i->X_ecran, inst->pixmap, inst->window, i->context, (9*7*8+16+23-(9*8*7+8-1))/2+4, 366+4, 9*8*7+8-8-1, 20,
	    (9*7*8+16+23-(9*8*7+8-1))/2+4, 366+4);
  draw_keyboard_cur_pos(i, inst);
}

void instrument_enter_subwin_0(INTERFACE *i, instrument *inst)
{
  redraw_volume_envelope(i, inst);
  draw_volume_cur_pos(i, inst);
}

/* used by draw_around_subwin_1 and draw_around_subwin_4 */
static int pos[8][2]={
  {NIX+9+6*7+5, 5+1+4+4},
  {NIX+9+6*7+5, 5+1+4+4+13+3},
  {NIX+9+6*7+5, 5+1+4+4+13+3+13+6},
  {NIX+9+6*7+5, 5+1+4+4+13+3+13+6+13+3},
  {NIX+9+6*7+5, 5+1+4+4+(13+3+13+6)*2},
  {NIX+9+6*7+5, 5+1+4+4+(13+3+13+6)*2+13+3},
  {NIX+9+6*7+5, 5+1+4+4+(13+3+13+6)*3},
  {NIX+9+6*7+5, 5+1+4+4+(13+3+13+6)*3+13+3}
};

void draw_around_subwin_1(INTERFACE *i, instrument *inst, int type)
{
  draw_rectangle(i->X_ecran, inst->pixmap, i->context, pos[inst->cur_pos_1][0]-2, pos[inst->cur_pos_1][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, inst->window, i->context, pos[inst->cur_pos_1][0]-2, pos[inst->cur_pos_1][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
}

void instrument_enter_subwin_1(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_1(i, inst, IN);
}

void draw_around_subwin_2(INTERFACE *i, instrument *inst, int type)
{
  static int pos[3][2]={
    {3*5+2*6, 65*2+8+21+3+2+4},
    {3*5+2*6+24*6, 65*2+8+21+3+2+4},
    {3*5+2*6+40*6, 65*2+8+21+3+2+4}
  };

  draw_rectangle(i->X_ecran, inst->pixmap, i->context, pos[inst->cur_pos_2][0]-2, pos[inst->cur_pos_2][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, inst->window, i->context, pos[inst->cur_pos_2][0]-2, pos[inst->cur_pos_2][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
}

void instrument_enter_subwin_2(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_2(i, inst, IN);
}

void instrument_enter_subwin_3(INTERFACE *i, instrument *inst)
{
  redraw_panning_envelope(i, inst);
  draw_panning_cur_pos(i, inst);
}

void draw_around_subwin_4(INTERFACE *i, instrument *inst, int type)
{
  draw_rectangle(i->X_ecran, inst->pixmap, i->context, pos[inst->cur_pos_4][0]-2, PINY+pos[inst->cur_pos_4][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, inst->window, i->context, pos[inst->cur_pos_4][0]-2, PINY+pos[inst->cur_pos_4][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
}

void instrument_enter_subwin_4(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_4(i, inst, IN);
}

void draw_around_subwin_5(INTERFACE *i, instrument *inst, int type)
{
  static int pos[3][2]={
    {3*5+2*6-3, PINY-2+65*2+8+21+3+2+4},
    {3*5+2*6+24*6+3, PINY-2+65*2+8+21+3+2+4},
    {3*5+2*6+40*6+3, PINY-2+65*2+8+21+3+2+4}
  };

  draw_rectangle(i->X_ecran, inst->pixmap, i->context, pos[inst->cur_pos_5][0]-2, pos[inst->cur_pos_5][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, inst->window, i->context, pos[inst->cur_pos_5][0]-2, pos[inst->cur_pos_5][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
}

void instrument_enter_subwin_5(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_5(i, inst, IN);
}

void draw_around_subwin_6(INTERFACE *i, instrument *inst, int type)
{
  static int pos[12][2]={
    {VFX+9+6*7+5, 5+VFY+1+4+4},
    {VFX+9+6*7+5, 5+VFY+1+4+4+13+3},

    {VFX+50, VFY+74},
    {VFX+50, VFY+74+20},
    {VFX+50, VFY+74+20*2},
    {VFX+50, VFY+74+20*3},

    {VFX+9+6*7+5, 5+VFY+1+4+4+(13+3+13+6)*4},
    {VFX+9+6*7+5, 5+VFY+1+4+4+(13+3+13+6)*4+13+3},
    {VFX+9+6*7+5, 5+VFY+1+4+4+(13+3+13+6)*5},
    {VFX+9+6*7+5, 5+VFY+1+4+4+(13+3+13+6)*5+13+3},
    {VFX+9+6*7+5, 5+VFY+1+4+4+(13+3+13+6)*6},
    {VFX+9+6*7+5, 5+VFY+1+4+4+(13+3+13+6)*6+13+3},
  };
  static int p[12]={16, 16, 13, 13, 13, 13, 16, 16, 16, 16, 16, 16};

  draw_rectangle(i->X_ecran, inst->pixmap, i->context, pos[inst->cur_pos_6][0]-2, pos[inst->cur_pos_6][1]-2,
		 p[inst->cur_pos_6], p[inst->cur_pos_6], 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, inst->window, i->context, pos[inst->cur_pos_6][0]-2, pos[inst->cur_pos_6][1]-2,
		 p[inst->cur_pos_6], p[inst->cur_pos_6], 1,
		 type==IN ? BLACK : GREY);
}

void instrument_enter_subwin_6(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_6(i, inst, IN);
}

void instrument_enter_subwin_7(INTERFACE *i, instrument *inst)
{
  redraw_keyboard(i, inst);
  draw_keyboard_cur_pos(i, inst);
}

void instrument_enter_subwin_8(INTERFACE *i, instrument *inst)
{
  /* we simply close the window */
  XDestroyWindow(i->X_ecran, inst->window);
  XFreePixmap(i->X_ecran, inst->pixmap);
  inst->is_shown=0;
}

void instrument_exit_subwin_0(INTERFACE *i, instrument *inst)
{
  redraw_volume_envelope(i, inst);
  clear_volume_cur_pos(i, inst);
}

void instrument_exit_subwin_1(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_1(i, inst, OUT);
}

void instrument_exit_subwin_2(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_2(i, inst, OUT);
}

void instrument_exit_subwin_3(INTERFACE *i, instrument *inst)
{
  redraw_panning_envelope(i, inst);
  clear_panning_cur_pos(i, inst);
}

void instrument_exit_subwin_4(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_4(i, inst, OUT);
}

void instrument_exit_subwin_5(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_5(i, inst, OUT);
}

void instrument_exit_subwin_6(INTERFACE *i, instrument *inst)
{
  draw_around_subwin_6(i, inst, OUT);
}

void instrument_exit_subwin_7(INTERFACE *i, instrument *inst)
{
  redraw_keyboard(i, inst);
  clear_keyboard_cur_pos(i, inst);
}

void instrument_exit_subwin_8(INTERFACE *i, instrument *inst)
{
}

/* look if there is space after the pos */
/* return 1 if no space, 0 otherwise */
/* space is there if :
 *	pos is the last point but is not in 324 or pos is not the last point and the next is not close to it */
int no_space_after(instrument *inst, int pos)
{
  /* last point is nb_point-2 because we did inc nb_point */
  if (pos==inst->nb_volume_points-2)
    return (inst->volume_envelop[pos][0]==324);
  return (inst->volume_envelop[pos][0]==inst->volume_envelop[pos+1][0]-1);
}

void instrument_subwin_0(INTERFACE *i, instrument *inst, KeySym ks)
{
  extern unsigned int status;

  switch(ks+(status<<16)) {
    case XK_Right :
      /* if no point, do nothing */
      if (!inst->nb_volume_points || !inst->cur_pos_0)
	break;
      /* if top right, impossible to go more */
      if (inst->cur_pos_0==inst->nb_volume_points-1) { /* don't forget the {}, other the code doesnt mean what we expect */
	if (inst->volume_envelop[inst->cur_pos_0][0]==324)
	  break;
      } else /* there is a next point */
	/* if we are close to the next point, can't move more */
	if (inst->volume_envelop[inst->cur_pos_0][0]>=inst->volume_envelop[inst->cur_pos_0+1][0]-1)
	  break;
      /* everything ok */
      inst->volume_envelop[inst->cur_pos_0][0]++;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Left :
      if (!inst->nb_volume_points || !inst->cur_pos_0)
	break;
      if (inst->volume_envelop[inst->cur_pos_0][0]<=inst->volume_envelop[inst->cur_pos_0-1][0]+1)
	break;
      inst->volume_envelop[inst->cur_pos_0][0]--;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Down :
      if (!inst->nb_volume_points)
	break;
      if (!inst->volume_envelop[inst->cur_pos_0][1])
	break;
      inst->volume_envelop[inst->cur_pos_0][1]--;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Up :
      if (!inst->nb_volume_points)
	break;
      if (inst->volume_envelop[inst->cur_pos_0][1]==64)
	break;
      inst->volume_envelop[inst->cur_pos_0][1]++;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Right+(ShiftMask<<16) :
      if (!inst->nb_volume_points || !inst->cur_pos_0)
	break;
      if (inst->cur_pos_0==inst->nb_volume_points-1) {
	if (inst->volume_envelop[inst->cur_pos_0][0]==324)
	  break;
      } else
	if (inst->volume_envelop[inst->cur_pos_0][0]>=inst->volume_envelop[inst->cur_pos_0+1][0]-1)
	  break;
      inst->volume_envelop[inst->cur_pos_0][0]+=8;
      if (inst->cur_pos_0==inst->nb_volume_points-1) {
	if (inst->volume_envelop[inst->cur_pos_0][0]>324)
	  inst->volume_envelop[inst->cur_pos_0][0]=324;
      } else
	if (inst->volume_envelop[inst->cur_pos_0][0]>inst->volume_envelop[inst->cur_pos_0+1][0]-1)
	  inst->volume_envelop[inst->cur_pos_0][0]=inst->volume_envelop[inst->cur_pos_0+1][0]-1;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Left+(ShiftMask<<16) :
      if (!inst->nb_volume_points || !inst->cur_pos_0)
	break;
      if (inst->volume_envelop[inst->cur_pos_0][0]<=inst->volume_envelop[inst->cur_pos_0-1][0]+1)
	break;
      inst->volume_envelop[inst->cur_pos_0][0]-=8;
      if (inst->volume_envelop[inst->cur_pos_0][0]<inst->volume_envelop[inst->cur_pos_0-1][0]+1)
	inst->volume_envelop[inst->cur_pos_0][0]=inst->volume_envelop[inst->cur_pos_0-1][0]+1;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Down+(ShiftMask<<16) :
      if (!inst->nb_volume_points)
	break;
      if (!inst->volume_envelop[inst->cur_pos_0][1])
	break;
      inst->volume_envelop[inst->cur_pos_0][1]-=8;
      if (inst->volume_envelop[inst->cur_pos_0][1]<0)
	inst->volume_envelop[inst->cur_pos_0][1]=0;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Up+(ShiftMask<<16) :
      if (!inst->nb_volume_points)
	break;
      if (inst->volume_envelop[inst->cur_pos_0][1]==64)
	break;
      inst->volume_envelop[inst->cur_pos_0][1]+=8;
      if (inst->volume_envelop[inst->cur_pos_0][1]>64)
	inst->volume_envelop[inst->cur_pos_0][1]=64;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Tab :
      if (!inst->nb_volume_points)
	break;
      inst->cur_pos_0++;
      if (inst->cur_pos_0==inst->nb_volume_points)
	inst->cur_pos_0=0;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_Tab+(ControlMask<<16) :
    case XK_Tab+(ShiftMask<<16) :
      if (!inst->nb_volume_points)
	break;
      inst->cur_pos_0--;
      if (inst->cur_pos_0==-1)
	inst->cur_pos_0=inst->nb_volume_points-1;
      redraw_volume_envelope(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    /* for the following, the draw_volume_cur_pos are not all necessary, but i don't want to think, so put it everywhere! */
    case XK_Insert : {
      int after;
      if (inst->nb_volume_points==12)
	break;
      inst->nb_volume_points++;
      /* normally, we insert after the current point, but there are some exceptions */
      /* first, maybe there is no point, so we create one */
      if (inst->nb_volume_points==1) {
	inst->volume_envelop[0][0]=0;
	inst->volume_envelop[0][1]=32;
	inst->cur_pos_0=0;
	redraw_volume_envelope(i, inst);
	redraw_nb_points_volume(i, inst);
	draw_volume_cur_pos(i, inst);
	break;
      }
      after=inst->cur_pos_0;
      /* then, the current point may be the last one, so we try to insert after if there is place enough,
       * otherwise, we try before (in the line with the previous point, if there is space. If not, then the
       * point before, we _must_ find a hole)
       */
      if (inst->cur_pos_0==inst->nb_volume_points-2) {
	if (inst->volume_envelop[inst->cur_pos_0][0]==324)
	  goto find_before;
	goto found_after;
      }
      /* then maybe there is no space after the current point, so we go one point later, until we find a hole.
       * If there is no hole, have to try to insert before (code above)
       */
      while (after!=inst->nb_volume_points-1 && no_space_after(inst, after))
	after++;
      if (after==inst->nb_volume_points-1)
	goto find_before;
      /* here we are ! there is space, so we insert it */
      goto found_after;

      /* here we look before, we are sure to find a hole at one time */
      find_before:
      after=(inst->cur_pos_0++)-1;
      while (after!=-1 && no_space_after(inst, after))
	after--;
      if (after==-1) {
	fprintf(stderr, "sub_instrument.instrument_subwin_0 impossible to insert a point. That's not natural. Contact the"
		"author as fast as you can. Send him your module and give him this message too. Thank you.\n");
	XBell(i->X_ecran, 0);
      }

      found_after:
      /* ok, here we have space after "after" */
      /* is "after" the last point ? */
      if (after==inst->nb_volume_points-2) {
	/* yes, so we create a new point at pos (after.x+16>324 ? 324 : after.x+16, after.y) */
	inst->volume_envelop[after+1][0]=inst->volume_envelop[after][0]+16;
	if (inst->volume_envelop[after+1][0]>324)
	  inst->volume_envelop[after+1][0]=324;
	inst->volume_envelop[after+1][1]=inst->volume_envelop[after][1];
	redraw_volume_envelope(i, inst);
	redraw_nb_points_volume(i, inst);
	draw_volume_cur_pos(i, inst);
	break;
      }
      /* no, so we must move the end one pos after */
      memmove(&inst->volume_envelop[after+2][0], &inst->volume_envelop[after+1][0], (10-after)*sizeof(short)*2);
      /* and put the new point */
      inst->volume_envelop[after+1][0]=(inst->volume_envelop[after][0]+inst->volume_envelop[after+2][0])>>1;
      inst->volume_envelop[after+1][1]=(inst->volume_envelop[after][1]+inst->volume_envelop[after+2][1])>>1;
      redraw_volume_envelope(i, inst);
      redraw_nb_points_volume(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    }
    case XK_Delete :
      if (inst->nb_volume_points==0)
	break;
      inst->nb_volume_points--;
      /* if no more points, simply do nothing */
      if (inst->nb_volume_points==0) {
	redraw_volume_envelope(i, inst);
	redraw_nb_points_volume(i, inst);
	clear_volume_cur_pos(i, inst);
	break;
      }
      /* verify sustain point, loop start loop end and dec it if necessary*/
      if (inst->volume_sustain_point==inst->nb_volume_points) {
	inst->volume_sustain_point--;
	redraw_sustain_point_volume(i, inst);
      }
      if (inst->volume_loop_start==inst->nb_volume_points) {
	inst->volume_loop_start--;
	redraw_loop_start_volume(i, inst);
      }
      if (inst->volume_loop_end==inst->nb_volume_points) {
	inst->volume_loop_end--;
	redraw_loop_end_volume(i, inst);
      }
      /* maybe the current point was the last */
      if (inst->cur_pos_0==inst->nb_volume_points) {
	inst->cur_pos_0--;
	redraw_volume_envelope(i, inst);
	redraw_nb_points_volume(i, inst);
	draw_volume_cur_pos(i, inst);
	break;
      }
      /* let's move data */
      memmove(&inst->volume_envelop[inst->cur_pos_0][0],
	      &inst->volume_envelop[inst->cur_pos_0+1][0], (11-inst->cur_pos_0)*sizeof(short)*2);
      /* maybe that's the first point, then the one after take a x=0 */
      if (inst->cur_pos_0==0)
	inst->volume_envelop[0][0]=0;
      redraw_volume_envelope(i, inst);
      redraw_nb_points_volume(i, inst);
      draw_volume_cur_pos(i, inst);
      break;
    case XK_s :
    case XK_S :
      /* the current point become the sustain-point (if not already) */
      if (inst->nb_volume_points==0)
	break;
      if (inst->volume_sustain_point==inst->cur_pos_0)
	break;
      inst->volume_sustain_point=inst->cur_pos_0;
      redraw_volume_envelope(i, inst);
      redraw_sustain_point_volume(i, inst);
      break;
    case XK_l :
    case XK_L :
      /* the current point become the loop_start-point (if not already) */
      if (inst->nb_volume_points==0)
	break;
      if (inst->volume_loop_start==inst->cur_pos_0)
	break;
      if (inst->cur_pos_0>inst->volume_loop_end)
	break;
      inst->volume_loop_start=inst->cur_pos_0;
      redraw_volume_envelope(i, inst);
      redraw_loop_start_volume(i, inst);
      break;
    case XK_e :
    case XK_E :
      /* the current point become the loop_end-point (if not already) */
      if (inst->nb_volume_points==0)
	break;
      if (inst->volume_loop_end==inst->cur_pos_0)
	break;
      if (inst->cur_pos_0<inst->volume_loop_start)
	break;
      inst->volume_loop_end=inst->cur_pos_0;
      redraw_volume_envelope(i, inst);
      redraw_loop_end_volume(i, inst);
      break;
  }
}

void instrument_subwin_1(INTERFACE *i, instrument *inst, KeySym ks)
{
  extern unsigned int status;

  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(inst->cur_pos_1) {
	case 0 :
	  status=0;
	  instrument_subwin_0(i, inst, XK_Insert);
	  clear_volume_cur_pos(i, inst);
	  break;
	case 1 :
	  instrument_subwin_0(i, inst, XK_Delete);
	  clear_volume_cur_pos(i, inst);
	  break;
	case 2 :
	  if (!inst->nb_volume_points)
	    break;
	  if (inst->volume_sustain_point>=inst->nb_volume_points-1)
	    break;
	  inst->volume_sustain_point++;
	  redraw_sustain_point_volume(i, inst);
	  if (inst->volume_type&2)
	    redraw_volume_envelope(i, inst);
	  break;
	case 3 :
	  if (!inst->nb_volume_points)
	    break;
	  if (inst->volume_sustain_point<=0)
	    break;
	  inst->volume_sustain_point--;
	  redraw_sustain_point_volume(i, inst);
	  if (inst->volume_type&2)
	    redraw_volume_envelope(i, inst);
	  break;
	case 4 :
	  if (!inst->nb_volume_points)
	    break;
	  if (inst->volume_loop_start>=inst->volume_loop_end)
	    break;
	  inst->volume_loop_start++;
	  redraw_loop_start_volume(i, inst);
	  if (inst->volume_type&4)
	    redraw_volume_envelope(i, inst);
	  break;
	case 5 :
	  if (!inst->nb_volume_points)
	    break;
	  if (inst->volume_loop_start<=0)
	    break;
	  inst->volume_loop_start--;
	  redraw_loop_start_volume(i, inst);
	  if (inst->volume_type&4)
	    redraw_volume_envelope(i, inst);
	  break;
	case 6 :
	  if (!inst->nb_volume_points)
	    break;
	  if (inst->volume_loop_end>=inst->nb_volume_points-1)
	    break;
	  inst->volume_loop_end++;
	  redraw_loop_end_volume(i, inst);
	  if (inst->volume_type&4)
	    redraw_volume_envelope(i, inst);
	  break;
	case 7 :
	  if (!inst->nb_volume_points)
	    break;
	  if (inst->volume_loop_end<=inst->volume_loop_start)
	    break;
	  inst->volume_loop_end--;
	  redraw_loop_end_volume(i, inst);
	  if (inst->volume_type&4)
	    redraw_volume_envelope(i, inst);
	  break;
      }
      break;
    case XK_Down :
      draw_around_subwin_1(i, inst, OUT);
      inst->cur_pos_1++;
      inst->cur_pos_1&=7;
      draw_around_subwin_1(i, inst, IN);
      break;
    case XK_Up :
      draw_around_subwin_1(i, inst, OUT);
      inst->cur_pos_1--;
      inst->cur_pos_1&=7;
      draw_around_subwin_1(i, inst, IN);
      break;
  }
}

void instrument_subwin_2(INTERFACE *i, instrument *inst, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(inst->cur_pos_2) {
	case 0 :
	  inst->volume_type^=1;
	  redraw_use_volume(i, inst);
	  break;
	case 1 :
	  inst->volume_type^=2;
	  redraw_use_volume(i, inst);
	  if (inst->nb_volume_points)
	    redraw_volume_envelope(i, inst);
	  break;
	case 2 :
	  inst->volume_type^=4;
	  redraw_use_volume(i, inst);
	  if (inst->nb_volume_points)
	    redraw_volume_envelope(i, inst);
	  break;
      }
      break;
    case XK_Right :
      draw_around_subwin_2(i, inst, OUT);
      inst->cur_pos_2++;
      if (inst->cur_pos_2>2)
	inst->cur_pos_2=0;
      draw_around_subwin_2(i, inst, IN);
      break;
    case XK_Left :
      draw_around_subwin_2(i, inst, OUT);
      inst->cur_pos_2--;
      if (inst->cur_pos_2==-1)
	inst->cur_pos_2=2;
      draw_around_subwin_2(i, inst, IN);
      break;
  }
}

int no_space_after_pan(instrument *inst, int pos)
{
  /* last point is nb_point-2 because we did inc nb_point */
  if (pos==inst->nb_panning_points-2)
    return (inst->panning_envelop[pos][0]==324);
  return (inst->panning_envelop[pos][0]==inst->panning_envelop[pos+1][0]-1);
}

void instrument_subwin_3(INTERFACE *i, instrument *inst, KeySym ks)
{
  extern unsigned int status;

  switch(ks+(status<<16)) {
    case XK_Right :
      if (!inst->nb_panning_points || !inst->cur_pos_3)
	break;
      if (inst->cur_pos_3==inst->nb_panning_points-1) {
	if (inst->panning_envelop[inst->cur_pos_3][0]==324)
	  break;
      } else
	if (inst->panning_envelop[inst->cur_pos_3][0]>=inst->panning_envelop[inst->cur_pos_3+1][0]-1)
	  break;
      inst->panning_envelop[inst->cur_pos_3][0]++;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Left :
      if (!inst->nb_panning_points || !inst->cur_pos_3)
	break;
      if (inst->panning_envelop[inst->cur_pos_3][0]<=inst->panning_envelop[inst->cur_pos_3-1][0]+1)
	break;
      inst->panning_envelop[inst->cur_pos_3][0]--;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Down :
      if (!inst->nb_panning_points)
	break;
      if (!inst->panning_envelop[inst->cur_pos_3][1])
	break;
      inst->panning_envelop[inst->cur_pos_3][1]--;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Up :
      if (!inst->nb_panning_points)
	break;
      if (inst->panning_envelop[inst->cur_pos_3][1]==63)
	break;
      inst->panning_envelop[inst->cur_pos_3][1]++;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Right+(ShiftMask<<16) :
      if (!inst->nb_panning_points || !inst->cur_pos_3)
	break;
      if (inst->cur_pos_3==inst->nb_panning_points-1) {
	if (inst->panning_envelop[inst->cur_pos_3][0]==324)
	  break;
      } else
	if (inst->panning_envelop[inst->cur_pos_3][0]>=inst->panning_envelop[inst->cur_pos_3+1][0]-1)
	  break;
      inst->panning_envelop[inst->cur_pos_3][0]+=8;
      if (inst->cur_pos_3==inst->nb_panning_points-1) {
	if (inst->panning_envelop[inst->cur_pos_3][0]>324)
	  inst->panning_envelop[inst->cur_pos_3][0]=324;
      } else
	if (inst->panning_envelop[inst->cur_pos_3][0]>inst->panning_envelop[inst->cur_pos_3+1][0]-1)
	  inst->panning_envelop[inst->cur_pos_3][0]=inst->panning_envelop[inst->cur_pos_3+1][0]-1;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Left+(ShiftMask<<16) :
      if (!inst->nb_panning_points || !inst->cur_pos_3)
	break;
      if (inst->panning_envelop[inst->cur_pos_3][0]<=inst->panning_envelop[inst->cur_pos_3-1][0]+1)
	break;
      inst->panning_envelop[inst->cur_pos_3][0]-=8;
      if (inst->panning_envelop[inst->cur_pos_3][0]<inst->panning_envelop[inst->cur_pos_3-1][0]+1)
	inst->panning_envelop[inst->cur_pos_3][0]=inst->panning_envelop[inst->cur_pos_3-1][0]+1;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Down+(ShiftMask<<16) :
      if (!inst->nb_panning_points)
	break;
      if (!inst->panning_envelop[inst->cur_pos_3][1])
	break;
      inst->panning_envelop[inst->cur_pos_3][1]-=8;
      if (inst->panning_envelop[inst->cur_pos_3][1]<0)
	inst->panning_envelop[inst->cur_pos_3][1]=0;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Up+(ShiftMask<<16) :
      if (!inst->nb_panning_points)
	break;
      if (inst->panning_envelop[inst->cur_pos_3][1]==63)
	break;
      inst->panning_envelop[inst->cur_pos_3][1]+=8;
      if (inst->panning_envelop[inst->cur_pos_3][1]>63)
	inst->panning_envelop[inst->cur_pos_3][1]=63;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Tab :
      if (!inst->nb_panning_points)
	break;
      inst->cur_pos_3++;
      if (inst->cur_pos_3==inst->nb_panning_points)
	inst->cur_pos_3=0;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Tab+(ControlMask<<16) :
    case XK_Tab+(ShiftMask<<16) :
      if (!inst->nb_panning_points)
	break;
      inst->cur_pos_3--;
      if (inst->cur_pos_3==-1)
	inst->cur_pos_3=inst->nb_panning_points-1;
      redraw_panning_envelope(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_Insert : {
      int after;
      if (inst->nb_panning_points==12)
	break;
      inst->nb_panning_points++;
      if (inst->nb_panning_points==1) {
	inst->panning_envelop[0][0]=0;
	inst->panning_envelop[0][1]=32;
	inst->cur_pos_3=0;
	redraw_panning_envelope(i, inst);
	redraw_nb_points_panning(i, inst);
	draw_panning_cur_pos(i, inst);
	break;
      }
      after=inst->cur_pos_3;
      if (inst->cur_pos_3==inst->nb_panning_points-2) {
	if (inst->panning_envelop[inst->cur_pos_3][0]==324)
	  goto find_before_pan;
	goto found_after_pan;
      }
      while (after!=inst->nb_panning_points-1 && no_space_after_pan(inst, after))
	after++;
      if (after==inst->nb_panning_points-1)
	goto find_before_pan;
      goto found_after_pan;

      find_before_pan:
      after=(inst->cur_pos_3++)-1;
      while (after!=-1 && no_space_after_pan(inst, after))
	after--;
      if (after==-1) {
	fprintf(stderr, "sub_instrument.instrument_subwin_3 impossible to insert a point. That's not natural. Contact the"
		"author as fast as you can. Send him your module and give him this message too. Thank you.\n");
	XBell(i->X_ecran, 0);
      }

      found_after_pan:
      if (after==inst->nb_panning_points-2) {
	inst->panning_envelop[after+1][0]=inst->panning_envelop[after][0]+16;
	if (inst->panning_envelop[after+1][0]>324)
	  inst->panning_envelop[after+1][0]=324;
	inst->panning_envelop[after+1][1]=inst->panning_envelop[after][1];
	redraw_panning_envelope(i, inst);
	redraw_nb_points_panning(i, inst);
	draw_panning_cur_pos(i, inst);
	break;
      }
      memmove(&inst->panning_envelop[after+2][0], &inst->panning_envelop[after+1][0], (10-after)*sizeof(short)*2);
      inst->panning_envelop[after+1][0]=(inst->panning_envelop[after][0]+inst->panning_envelop[after+2][0])>>1;
      inst->panning_envelop[after+1][1]=(inst->panning_envelop[after][1]+inst->panning_envelop[after+2][1])>>1;
      redraw_panning_envelope(i, inst);
      redraw_nb_points_panning(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    }
    case XK_Delete :
      if (inst->nb_panning_points==0)
	break;
      inst->nb_panning_points--;
      if (inst->nb_panning_points==0) {
	redraw_panning_envelope(i, inst);
	redraw_nb_points_panning(i, inst);
	clear_panning_cur_pos(i, inst);
	break;
      }
      if (inst->panning_sustain_point==inst->nb_panning_points) {
	inst->panning_sustain_point--;
	redraw_sustain_point_panning(i, inst);
      }
      if (inst->panning_loop_start==inst->nb_panning_points) {
	inst->panning_loop_start--;
	redraw_loop_start_panning(i, inst);
      }
      if (inst->panning_loop_end==inst->nb_panning_points) {
	inst->panning_loop_end--;
	redraw_loop_end_panning(i, inst);
      }
      if (inst->cur_pos_3==inst->nb_panning_points) {
	inst->cur_pos_3--;
	redraw_panning_envelope(i, inst);
	redraw_nb_points_panning(i, inst);
	draw_panning_cur_pos(i, inst);
	break;
      }
      memmove(&inst->panning_envelop[inst->cur_pos_3][0],
	      &inst->panning_envelop[inst->cur_pos_3+1][0], (11-inst->cur_pos_3)*sizeof(short)*2);
      if (inst->cur_pos_3==0)
	inst->panning_envelop[0][0]=0;
      redraw_panning_envelope(i, inst);
      redraw_nb_points_panning(i, inst);
      draw_panning_cur_pos(i, inst);
      break;
    case XK_s :
    case XK_S :
      if (inst->nb_panning_points==0)
	break;
      if (inst->panning_sustain_point==inst->cur_pos_3)
	break;
      inst->panning_sustain_point=inst->cur_pos_3;
      redraw_panning_envelope(i, inst);
      redraw_sustain_point_panning(i, inst);
      break;
    case XK_l :
    case XK_L :
      if (inst->nb_panning_points==0)
	break;
      if (inst->panning_loop_start==inst->cur_pos_3)
	break;
      if (inst->cur_pos_3>inst->panning_loop_end)
	break;
      inst->panning_loop_start=inst->cur_pos_3;
      redraw_panning_envelope(i, inst);
      redraw_loop_start_panning(i, inst);
      break;
    case XK_e :
    case XK_E :
      if (inst->nb_panning_points==0)
	break;
      if (inst->panning_loop_end==inst->cur_pos_3)
	break;
      if (inst->cur_pos_3<inst->panning_loop_start)
	break;
      inst->panning_loop_end=inst->cur_pos_3;
      redraw_panning_envelope(i, inst);
      redraw_loop_end_panning(i, inst);
      break;
  }
}

void instrument_subwin_4(INTERFACE *i, instrument *inst, KeySym ks)
{
  extern unsigned int status;

  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(inst->cur_pos_4) {
	case 0 :
	  status=0;
	  instrument_subwin_3(i, inst, XK_Insert);
	  clear_panning_cur_pos(i, inst);
	  break;
	case 1 :
	  instrument_subwin_3(i, inst, XK_Delete);
	  clear_panning_cur_pos(i, inst);
	  break;
	case 2 :
	  if (!inst->nb_panning_points)
	    break;
	  if (inst->panning_sustain_point>=inst->nb_panning_points-1)
	    break;
	  inst->panning_sustain_point++;
	  redraw_sustain_point_panning(i, inst);
	  if (inst->panning_type&2)
	    redraw_panning_envelope(i, inst);
	  break;
	case 3 :
	  if (!inst->nb_panning_points)
	    break;
	  if (inst->panning_sustain_point<=0)
	    break;
	  inst->panning_sustain_point--;
	  redraw_sustain_point_panning(i, inst);
	  if (inst->panning_type&2)
	    redraw_panning_envelope(i, inst);
	  break;
	case 4 :
	  if (!inst->nb_panning_points)
	    break;
	  if (inst->panning_loop_start>=inst->panning_loop_end)
	    break;
	  inst->panning_loop_start++;
	  redraw_loop_start_panning(i, inst);
	  if (inst->panning_type&4)
	    redraw_panning_envelope(i, inst);
	  break;
	case 5 :
	  if (!inst->nb_panning_points)
	    break;
	  if (inst->panning_loop_start<=0)
	    break;
	  inst->panning_loop_start--;
	  redraw_loop_start_panning(i, inst);
	  if (inst->panning_type&4)
	    redraw_panning_envelope(i, inst);
	  break;
	case 6 :
	  if (!inst->nb_panning_points)
	    break;
	  if (inst->panning_loop_end>=inst->nb_panning_points-1)
	    break;
	  inst->panning_loop_end++;
	  redraw_loop_end_panning(i, inst);
	  if (inst->panning_type&4)
	    redraw_panning_envelope(i, inst);
	  break;
	case 7 :
	  if (!inst->nb_panning_points)
	    break;
	  if (inst->panning_loop_end<=inst->panning_loop_start)
	    break;
	  inst->panning_loop_end--;
	  redraw_loop_end_panning(i, inst);
	  if (inst->panning_type&4)
	    redraw_panning_envelope(i, inst);
	  break;
      }
      break;
    case XK_Down :
      draw_around_subwin_4(i, inst, OUT);
      inst->cur_pos_4++;
      inst->cur_pos_4&=7;
      draw_around_subwin_4(i, inst, IN);
      break;
    case XK_Up :
      draw_around_subwin_4(i, inst, OUT);
      inst->cur_pos_4--;
      inst->cur_pos_4&=7;
      draw_around_subwin_4(i, inst, IN);
      break;
  }
}

void instrument_subwin_5(INTERFACE *i, instrument *inst, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(inst->cur_pos_5) {
	case 0 :
	  inst->panning_type^=1;
	  redraw_use_panning(i, inst);
	  break;
	case 1 :
	  inst->panning_type^=2;
	  redraw_use_panning(i, inst);
	  if (inst->nb_panning_points)
	    redraw_panning_envelope(i, inst);
	  break;
	case 2 :
	  inst->panning_type^=4;
	  redraw_use_panning(i, inst);
	  if (inst->nb_panning_points)
	    redraw_panning_envelope(i, inst);
	  break;
      }
      break;
    case XK_Right :
      draw_around_subwin_5(i, inst, OUT);
      inst->cur_pos_5++;
      if (inst->cur_pos_5>2)
	inst->cur_pos_5=0;
      draw_around_subwin_5(i, inst, IN);
      break;
    case XK_Left :
      draw_around_subwin_5(i, inst, OUT);
      inst->cur_pos_5--;
      if (inst->cur_pos_5==-1)
	inst->cur_pos_5=2;
      draw_around_subwin_5(i, inst, IN);
      break;
  }
}

void instrument_subwin_6(INTERFACE *i, instrument *inst, KeySym ks)
{
  extern unsigned int status;

  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(inst->cur_pos_6) {
	case 0 :
	  if (inst->volume_fadeout==0xfff) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ControlMask) {
	    inst->volume_fadeout+=0x100;
	    if (inst->volume_fadeout>0xfff)
	      inst->volume_fadeout=0xfff;
	  } else
	  if (status==ShiftMask) {
	    inst->volume_fadeout+=0x10;
	    if (inst->volume_fadeout>0xfff)
	      inst->volume_fadeout=0xfff;
	  } else
	    inst->volume_fadeout++;
	  redraw_fadeout(i, inst);
	  break;
	case 1 :
	  if (inst->volume_fadeout==0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ControlMask) {
	    inst->volume_fadeout-=0x100;
	    if (inst->volume_fadeout&0xf000)
	      inst->volume_fadeout=0;
	  } else
	  if (status==ShiftMask) {
	    inst->volume_fadeout-=0x10;
	    if (inst->volume_fadeout&0xf000)
	      inst->volume_fadeout=0;
	  } else
	    inst->volume_fadeout--;
	  redraw_fadeout(i, inst);
	  break;
	case 2 :
	  if (inst->vibrato_type==0)
	    break;
	  inst->vibrato_type=0;
	  redraw_vib_type(i, inst);
	  break;
	case 3 :
	  if (inst->vibrato_type==1)
	    break;
	  inst->vibrato_type=1;
	  redraw_vib_type(i, inst);
	  break;
	case 4 :
	  if (inst->vibrato_type==2)
	    break;
	  inst->vibrato_type=2;
	  redraw_vib_type(i, inst);
	  break;
	case 5 :
	  if (inst->vibrato_type==3)
	    break;
	  inst->vibrato_type=3;
	  redraw_vib_type(i, inst);
	  break;
	case 6 :
	  if (inst->vibrato_rate==0x3f) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask) {
	    inst->vibrato_rate+=0x10;
	    if (inst->vibrato_rate>0x3f)
	      inst->vibrato_rate=0x3f;
	  } else
	    inst->vibrato_rate++;
	  redraw_vib_speed(i, inst);
	  break;
	case 7 :
	  if (inst->vibrato_rate==0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask) {
	    int a=inst->vibrato_rate-0x10;
	    if (a<0)
	      inst->vibrato_rate=0;
	    else
	      inst->vibrato_rate=a;
	  } else
	    inst->vibrato_rate--;
	  redraw_vib_speed(i, inst);
	  break;
	case 8 :
	  if (inst->vibrato_sweep==0xff) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask) {
	    int a=inst->vibrato_sweep+0x10;
	    if (a>0xff)
	      inst->vibrato_sweep=0xff;
	    else
	      inst->vibrato_sweep=a;
	  } else
	    inst->vibrato_sweep++;
	  redraw_vib_sweep(i, inst);
	  break;
	case 9 :
	  if (inst->vibrato_sweep==0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask) {
	    int a=inst->vibrato_sweep-0x10;
	    if (a<0)
	      inst->vibrato_sweep=0;
	    else
	      inst->vibrato_sweep=a;
	  } else
	    inst->vibrato_sweep--;
	  redraw_vib_sweep(i, inst);
	  break;
	case 10 :
	  if (inst->vibrato_depth==0xf) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  inst->vibrato_depth++;
	  redraw_vib_depth(i, inst);
	  break;
	case 11 :
	  if (inst->vibrato_depth==0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  inst->vibrato_depth--;
	  redraw_vib_depth(i, inst);
	  break;
      }
      break;
    case XK_Down :
      draw_around_subwin_6(i, inst, OUT);
      inst->cur_pos_6++;
      if (inst->cur_pos_6>11)
	inst->cur_pos_6=0;
      draw_around_subwin_6(i, inst, IN);
      break;
    case XK_Up :
      draw_around_subwin_6(i, inst, OUT);
      inst->cur_pos_6--;
      if (inst->cur_pos_6==-1)
	inst->cur_pos_6=11;
      draw_around_subwin_6(i, inst, IN);
      break;
  }
}

void instrument_subwin_7(INTERFACE *i, instrument *inst, KeySym ks)
{
  extern unsigned int status;

  if ((ks>='0' && ks<='9') || (ks>='A' && ks<='F') || (ks>='a' && ks<='f')) {
    int note=ks>='0' && ks<='9' ? ks-'0' : ks>='A' && ks<='F' ? ks-'A'+10 : ks-'a'+10;
    if (inst->sample_number[inst->cur_pos_7]!=note) {
      inst->sample_number[inst->cur_pos_7]=note;
      if (inst->cur_pos_7!=95)
	inst->cur_pos_7++;
      redraw_keyboard(i, inst);
      return;
    }
    if (inst->cur_pos_7!=95) {
      inst->cur_pos_7++;
      redraw_keyboard(i, inst);
      return;
    }
    return;
  }

  switch(ks+(status<<16)) {
    case XK_Return :
    case XK_space :
      break;
    case XK_Right :
      if (inst->cur_pos_7==95)
	break;
      inst->cur_pos_7++;
      redraw_keyboard(i, inst);
      break;
    case XK_Left :
      if (inst->cur_pos_7==0)
	break;
      inst->cur_pos_7--;
      redraw_keyboard(i, inst);
      break;
    case XK_Right+(ShiftMask<<16) :
      if (inst->cur_pos_7>=95-12)
	break;
      inst->cur_pos_7+=12;
      redraw_keyboard(i, inst);
      break;
    case XK_Left+(ShiftMask<<16) :
      if (inst->cur_pos_7<12)
	break;
      inst->cur_pos_7-=12;
      redraw_keyboard(i, inst);
      break;
    case XK_Tab :
      if (inst->cur_pos_7==95-12)
	break;
      if (inst->cur_pos_7<95-12)
	inst->cur_pos_7+=12;
      inst->cur_pos_7-=inst->cur_pos_7%12;
      redraw_keyboard(i, inst);
      break;
    case XK_Tab+(ShiftMask<<16) :
      if (inst->cur_pos_7==0)
	break;
      if (inst->cur_pos_7 && inst->cur_pos_7 %12==0)
	inst->cur_pos_7--;
      inst->cur_pos_7-=inst->cur_pos_7%12;
      redraw_keyboard(i, inst);
      break;
  }
}

void instrument_subwin_8(INTERFACE *i, instrument *inst, KeySym ks)
{
}

void (*instrument_enter_subwin[9])(INTERFACE *, instrument *)=
{
  instrument_enter_subwin_0,
  instrument_enter_subwin_1,
  instrument_enter_subwin_2,
  instrument_enter_subwin_3,
  instrument_enter_subwin_4,
  instrument_enter_subwin_5,
  instrument_enter_subwin_6,
  instrument_enter_subwin_7,
  instrument_enter_subwin_8,
};

void (*instrument_exit_subwin[9])(INTERFACE *, instrument *)=
{
  instrument_exit_subwin_0,
  instrument_exit_subwin_1,
  instrument_exit_subwin_2,
  instrument_exit_subwin_3,
  instrument_exit_subwin_4,
  instrument_exit_subwin_5,
  instrument_exit_subwin_6,
  instrument_exit_subwin_7,
  instrument_exit_subwin_8,
};

void (*instrument_subwin[9])(INTERFACE *, instrument *, KeySym)=
{
  instrument_subwin_0,
  instrument_subwin_1,
  instrument_subwin_2,
  instrument_subwin_3,
  instrument_subwin_4,
  instrument_subwin_5,
  instrument_subwin_6,
  instrument_subwin_7,
  instrument_subwin_8,
};
