/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august september 1998.
 * This is total free software.
 *-------------------------------------
 * The sample editing, each subwindow. Big file, sorry.
 */

/* It is very possible that you'll find bugs (core-dumping bugs, i mean) in this file. */

#include "sub_sample.h"

#include <X11/keysym.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "interface.h"
#include "xm.h"
#include "screen.h"
#include "file_selector.h"
#include "wav.h"
#include "card.h"

/* some externs, didn't want to include */
void draw_sample_size(INTERFACE *, sample *);
void draw_sample(INTERFACE *, sample *);
void draw_loop_start(INTERFACE *, sample *);
void draw_loop_end(INTERFACE *, sample *);
void draw_fine_tune(INTERFACE *, sample *);
void draw_relative_tone(INTERFACE *, sample *);
void draw_volume(INTERFACE *, sample *);
void draw_panning(INTERFACE *, sample *);
void draw_8_16_bits(INTERFACE *, sample *);
void draw_use_loop(INTERFACE *, sample *);
void draw_subwin_4(INTERFACE *, sample *);
void draw_record_mixing_rate(INTERFACE *, sample *);
void draw_record_8_16_bits(INTERFACE *, sample *);
void draw_record_fragment_size(INTERFACE *, sample *);
void draw_record_nb_fragments(INTERFACE *, sample *);
void draw_record_micro_line(INTERFACE *, sample *);
void draw_record_input_volume(INTERFACE *, sample *);

extern unsigned long status;

void redraw_sample_size(INTERFACE *i, sample *samp)
{
  draw_sample_size(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    4+4+6*(57-8-5*2)+8+6*11+6*2, 128+8+8+13+4+3, 6*(8)+4, 12,
	    4+4+6*(57-8-5*2)+8+6*11+6*2, 128+8+8+13+4+3);
}

void redraw_sample(INTERFACE *i, sample *samp)
{
  draw_sample(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    7, 8, 512+2, 128,
	    7, 8);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context, 4+13+4+3, 128+8+8+3, 512+8-13*2-4*2-6, 13-6,
	    4+13+4+3, 128+8+8+3);
}

void redraw_loop_start(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=0)
    return;
  draw_loop_start(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XI+9+6*10+5+13+3-5*6, YI+1+5+4+8, (4+8)*6-4-16, 12,
	    XI+9+6*10+5+13+3-5*6, YI+1+5+4+8);
}

void redraw_loop_end(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=0)
    return;
  draw_loop_end(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XI+9+6*10+5+13+3-5*6, YI+1+5+4+13+3+13+6+8, (4+8)*6-4-16, 12,
	    XI+9+6*10+5+13+3-5*6, YI+1+5+4+13+3+13+6+8);
}

void redraw_fine_tune(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=0)
    return;
  draw_fine_tune(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XFR+9+6*10+5+13+3-2*6, YI+1+5+4+8, (4+4)*6-4-16, 12,
	    XFR+9+6*10+5+13+3-2*6, YI+1+5+4+8);
}

void redraw_relative_tone(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=0)
    return;
  draw_relative_tone(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XFR+9+6*10+5+13+3-2*6, YI+1+5+4+13+3+13+6+8, (4+3)*6-4-16, 12,
	    XFR+9+6*10+5+13+3-2*6, YI+1+5+4+13+3+13+6+8);
}

void redraw_volume(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=0)
    return;
  draw_volume(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XVP+9+6*10+5+13+3-3*6, YI+1+5+4+8, (4+2)*6-4-16, 12,
	    XVP+9+6*10+5+13+3-3*6, YI+1+5+4+8);
}

void redraw_panning(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=0)
    return;
  draw_panning(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XVP+9+6*10+5+13+3-3*6, YI+1+5+4+13+3+13+6+8, (4+2)*6-4-16, 12,
	    XVP+9+6*10+5+13+3-3*6, YI+1+5+4+13+3+13+6+8);
}

void redraw_8_16_bits(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=0)
    return;
  draw_8_16_bits(i, samp);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+11-9+1, 10, 10, LIGHTBLUE,
		     samp->sample_type&16 ? UP_3D : DOWN_3D);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+8+11+15-9+1, 10, 10, LIGHTBLUE,
		     samp->sample_type&16 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+8+11+15-9+25+1, 10, 10, LIGHTBLUE,
		     samp->mode_3_0 ? DOWN_3D : UP_3D);
}

void redraw_use_loop(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=0)
    return;
  draw_use_loop(i, samp);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XL+6*10+4, YI+5+4+18+4-5, 10, 10, LIGHTBLUE,
		     (samp->sample_type&3)==1 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XL+6*10+4, YI+5+4+18+4+15-5, 10, 10, LIGHTBLUE,
		     (samp->sample_type&3)==2 ? DOWN_3D : UP_3D);
}

void redraw_subwin_4(INTERFACE *i, sample *samp)
{
  draw_subwin_4(i, samp);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, 8+8*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE,
		     samp->subsubwin==0 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, 8+19*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE,
		     samp->subsubwin==1 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, 8+(42-8-5)*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE,
		     samp->subsubwin==2 ? DOWN_3D : UP_3D);
}

void redraw_record_mixing_rate(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=1)
    return;
  draw_record_mixing_rate(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XI+9+6*10+5+13+3-4*6, YI+1+5+4+8, (4+5)*6-4-16, 12,
	    XI+9+6*10+5+13+3-4*6, YI+1+5+4+8);
}

void redraw_record_8_16_bits(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=1)
    return;
  draw_record_8_16_bits(i, samp);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XI+9+6*8, YI+1+5+4+8+11-5+10*3-9, 10, 10, LIGHTBLUE,
		     samp->record_16b ? UP_3D : DOWN_3D);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XI+9+6*8, YI+1+5+4+8+11-5+10*5-9-5, 10, 10, LIGHTBLUE,
		     samp->record_16b ? DOWN_3D : UP_3D);
}

void redraw_record_fragment_size(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=1)
    return;
  draw_record_fragment_size(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XFS+9+6*10+5+13+3-1*6, YI+1+5+4+8, (4+6)*6-4-16, 12,
	    XFS+9+6*10+5+13+3-1*6, YI+1+5+4+8);
}

void redraw_record_nb_fragments(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=1)
    return;
  draw_record_nb_fragments(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XFS+9+6*10+5+13+3-1*6, YI+1+5+4+13+3+13+6+8, (4+3)*6-4-16, 12,
	    XFS+9+6*10+5+13+3-1*6, YI+1+5+4+13+3+13+6+8);
}

void redraw_record_micro_line(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=1)
    return;
  draw_record_micro_line(i, samp);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XMI+4, YI+5+4, 10, 10, LIGHTBLUE,
		     samp->record_micro_line ? UP_3D : DOWN_3D);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, XMI+4+6*12, YI+5+4, 10, 10, LIGHTBLUE,
		     samp->record_micro_line ? DOWN_3D : UP_3D);
}

void redraw_record_input_volume(INTERFACE *i, sample *samp)
{
  if (samp->cur_pos_4!=1)
    return;
  draw_record_input_volume(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context,
	    XMI+9+6*10+5+13+3-4*6, YV+1+5+4+8, (4+3)*6-4-16, 12,
	    XMI+9+6*10+5+13+3-4*6, YV+1+5+4+8);
}

void subwin_around_4(INTERFACE *i, sample *samp, int type)
{
  int p[3][2]={
    {8+8*6-3, 128+8+8+13+4+4},
    {8+19*6-3, 128+8+8+13+4+4},
    {8+(42-8-5)*6-3, 128+8+8+13+4+4}
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_4][0]-2, p[samp->cur_pos_4][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_4][0]-2, p[samp->cur_pos_4][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
}

void subwin_around_0_0(INTERFACE *i, sample *samp, int type)
{
  int p[4][2]={
    {XI+9+6*10+5-5*6, YI+1+5+4},
    {XI+9+6*10+5-5*6, YI+1+5+4+13+3},
    {XI+9+6*10+5-5*6, YI+1+5+4+13+3+13+6},
    {XI+9+6*10+5-5*6, YI+1+5+4+13+3+13+6+13+3}
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_0_0][0]-2, p[samp->cur_pos_0_0][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_0_0][0]-2, p[samp->cur_pos_0_0][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
}

void subwin_around_0_1(INTERFACE *i, sample *samp, int type)
{
  int p[4][2]={
    {XFR+9+6*10+5-2*6, YI+1+5+4},
    {XFR+9+6*10+5-2*6, YI+1+5+4+13+3},
    {XFR+9+6*10+5-2*6, YI+1+5+4+13+3+13+6},
    {XFR+9+6*10+5-2*6, YI+1+5+4+13+3+13+6+13+3}
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_0_1][0]-2, p[samp->cur_pos_0_1][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_0_1][0]-2, p[samp->cur_pos_0_1][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
}

void subwin_around_0_2(INTERFACE *i, sample *samp, int type)
{
  int p[4][2]={
    {XVP+9+6*10+5-3*6, YI+1+5+4},
    {XVP+9+6*10+5-3*6, YI+1+5+4+13+3},
    {XVP+9+6*10+5-3*6, YI+1+5+4+13+3+13+6},
    {XVP+9+6*10+5-3*6, YI+1+5+4+13+3+13+6+13+3}
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_0_2][0]-2, p[samp->cur_pos_0_2][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_0_2][0]-2, p[samp->cur_pos_0_2][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
}

void subwin_around_0_3(INTERFACE *i, sample *samp, int type)
{
  int p[3][2]={
    {XHS+9+6*10+5-3*6, YI+1+5+4+11-9+1},
    {XHS+9+6*10+5-3*6, YI+1+5+4+8+11+15-9+1},
    {XHS+9+6*10+5-3*6, YI+1+5+4+8+11+15-9+25+1},
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_0_3][0]-2, p[samp->cur_pos_0_3][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_0_3][0]-2, p[samp->cur_pos_0_3][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
}

void subwin_around_0_4(INTERFACE *i, sample *samp, int type)
{
  int p[2][2]={
    {XL+6*10+4, YI+5+4+18+4-5},
    {XL+6*10+4, YI+5+4+18+4+15-5},
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_0_4][0]-2, p[samp->cur_pos_0_4][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_0_4][0]-2, p[samp->cur_pos_0_4][1]-2, 13, 13, 1,
		 type==IN ? BLACK : GREY);
}

void subwin_around_1_0(INTERFACE *i, sample *samp, int type)
{
  int p[4][4]={
    {XI+9+6*10+5-4*6, YI+1+5+4, 13, 13},
    {XI+9+6*10+5-4*6, YI+1+5+4+13+3, 13, 13},
    {XI+9+6*8, YI+1+5+4+8+11-5+10*3-9, 10, 10},
    {XI+9+6*8, YI+1+5+4+8+11-5+10*5-9-5, 10, 10}
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_1_0][0]-2, p[samp->cur_pos_1_0][1]-2,
		 p[samp->cur_pos_1_0][2]+3, p[samp->cur_pos_1_0][3]+3, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_1_0][0]-2, p[samp->cur_pos_1_0][1]-2,
		 p[samp->cur_pos_1_0][2]+3, p[samp->cur_pos_1_0][3]+3, 1,
		 type==IN ? BLACK : GREY);
}

void subwin_around_1_1(INTERFACE *i, sample *samp, int type)
{
  int p[4][2]={
    {XFS+9+6*10+5-1*6, YI+1+5+4},
    {XFS+9+6*10+5-1*6, YI+1+5+4+13+3},
    {XFS+9+6*10+5-1*6, YI+1+5+4+13+3+13+6},
    {XFS+9+6*10+5-1*6, YI+1+5+4+13+3+13+6+13+3}
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_1_1][0]-2, p[samp->cur_pos_1_1][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_1_1][0]-2, p[samp->cur_pos_1_1][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
}

void subwin_around_1_3(INTERFACE *i, sample *samp, int type)
{
  int p[2][2]={
    {XMI+9+6*10+5-4*6, YV+1+5+4},
    {XMI+9+6*10+5-4*6, YV+1+5+4+13+3}
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_1_3][0]-2, p[samp->cur_pos_1_3][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_1_3][0]-2, p[samp->cur_pos_1_3][1]-2, 16, 16, 1,
		 type==IN ? BLACK : GREY);
}

void display_cur_pos_0(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, 28, 128+8+8+13+4+2, 6*8+6, 14, LIGHTBLUE);
  sprintf(s, "%8.8lX", samp->sample_type&16?samp->cur_pos_0<<1:samp->cur_pos_0);
  draw_string(i->X_ecran, samp->pixmap, i->context, 28+3, 128+8+8+13+4+13, s, i->little, BLUE);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context, 28, 128+8+8+13+4+2, 6*8+6, 14, 28, 128+8+8+13+4+2);
}

void sample_enter_subwin_0(INTERFACE *i, sample *samp)
{
  display_cur_pos_0(i, samp);
}

void sample_enter_subwin_1(INTERFACE *i, sample *samp)
{
}

void sample_enter_subwin_2(INTERFACE *i, sample *samp)
{
}

void sample_enter_subwin_3(INTERFACE *i, sample *samp)
{
}

void sample_enter_subwin_4(INTERFACE *i, sample *samp)
{
  subwin_around_4(i, samp, IN);
}

void sample_enter_subwin_5(INTERFACE *i, sample *samp)
{
  XDestroyWindow(i->X_ecran, samp->window);
  XFreePixmap(i->X_ecran, samp->pixmap);
  samp->is_shown=0;
}

void draw_pos_6(INTERFACE *i, sample *samp)
{
  #define X4		(250+200)
  #define Y4		(4+4+128+4+4+30+10)
  draw_box(i->X_ecran, samp->pixmap, i->context, X4+4, Y4+4+(samp->cur_pos_6?12:0), 6*3+6+12-8, 12, LIGHTBLUE);
  draw_box(i->X_ecran, samp->pixmap, i->context, X4+4, Y4+4+(samp->cur_pos_6?0:12), 6*3+6+12-8, 12, GREY);
  draw_string(i->X_ecran, samp->pixmap, i->context, X4+9, Y4+13, "Wav", i->little, BLACK);
  draw_string(i->X_ecran, samp->pixmap, i->context, X4+9, Y4+10+15, "Raw", i->little, BLACK);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context, X4, Y4, 6*3+6+12, 32, X4, Y4);
}

void sample_enter_subwin_6(INTERFACE *i, sample *samp)
{
  void around_sub_0(INTERFACE *, sample *, int);
  around_sub_0(i, samp, OUT);
  samp->cur_pos_6=0;
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, X4, Y4, 6*3+6+12, 32, GREY, UP_3D);
  draw_pos_6(i, samp);
}

void around_7(INTERFACE *i, sample *samp, int type)
{
  #define X5		(X4-45)
  #define Y5		(Y4)
  int p[4][4]={
    {X5+9+6*10+5-6*6, Y5+1+5+4, 13, 13},
    {X5+9+6*10+5-6*6, Y5+1+5+4+13+3, 13, 13},
    {X5+5+5, Y5+5+40, 3*6+4+8, 10+4+4},
    {X5+5+5+6*6, Y5+5+40, 7*6+4+8, 10+4+4}
  };
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, p[samp->cur_pos_7][0]-2, p[samp->cur_pos_7][1]-2,
		 p[samp->cur_pos_7][2]+3, p[samp->cur_pos_7][3]+3, 1, type==IN ? BLACK : GREY);
  draw_rectangle(i->X_ecran, samp->window, i->context, p[samp->cur_pos_7][0]-2, p[samp->cur_pos_7][1]-2,
		 p[samp->cur_pos_7][2]+3, p[samp->cur_pos_7][3]+3, 1, type==IN ? BLACK : GREY);
}

void draw_pos_7(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, X5+9+6*10+5+13+3-6*6, Y5+1+5+4+8, (4+5)*6-4-16, 12, 3);
  sprintf(s, "%5d", samp->rate_7);
  draw_string(i->X_ecran, samp->pixmap, i->context, X5+9+6*10+5+13+3-6*6+2, Y5+1+5+4+8+10, s, i->little, BLUE);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context, X5+9+6*10+5+13+3-6*6, Y5+1+5+4+8, (4+5)*6-4-16, 12,
	    X5+9+6*10+5+13+3-6*6, Y5+1+5+4+8);
}

void sample_enter_subwin_7(INTERFACE *i, sample *samp)
{
  void around_sub_0(INTERFACE *, sample *, int);
  around_sub_0(i, samp, OUT);
  samp->cur_pos_7=2;
  samp->rate_7=8000;
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, X5+5, Y5+5, 148-6*6+3*6-6*6+6, 63, 6, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, X5+9, Y5+1+5+4+8+11-2, "Rate", i->little, 0);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, X5+9+6*10+5-6*6, Y5+1+5+4, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, X5+9+6*10+5-6*6, Y5+1+5+4+13+3, UP_3D, ARROW_DOWN);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, X5+5+5, Y5+5+40, 3*6+4+8, 10+4+4, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, X5+5+5+8, Y5+5+40+12, "Ok", i->little, BLACK);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, X5+5+5+6*6, Y5+5+40, 7*6+4+8, 10+4+4, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, X5+5+5+6*6+8, Y5+5+40+12, "Cancel", i->little, BLACK);
  draw_pos_7(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context, X5+5, Y5+5, 148-6*6+3*6-6*6+6, 63,
	    X5+5, Y5+5);
  around_7(i, samp, IN);
}

void sample_enter_subwin_0_0(INTERFACE *i, sample *samp)
{
  subwin_around_0_0(i, samp, IN);
}

void sample_enter_subwin_0_1(INTERFACE *i, sample *samp)
{
  subwin_around_0_1(i, samp, IN);
}

void sample_enter_subwin_0_2(INTERFACE *i, sample *samp)
{
  subwin_around_0_2(i, samp, IN);
}

void sample_enter_subwin_0_3(INTERFACE *i, sample *samp)
{
  subwin_around_0_3(i, samp, IN);
}

void sample_enter_subwin_0_4(INTERFACE *i, sample *samp)
{
  subwin_around_0_4(i, samp, IN);
}

void sample_enter_subwin_0_5(INTERFACE *i, sample *samp)
{
  void sample_subwin_0(INTERFACE *, sample *, KeySym);
  extern void (*in_out_sample[])(INTERFACE *, sample *, int);
  status=0;
  sample_subwin_0(i, samp, XK_Delete);
  samp->mode=MOVING;
  in_out_sample[samp->subsubwin](i, samp, UP_3D);
}

void sample_enter_subwin_0_6(INTERFACE *i, sample *samp)
{
  void sample_subwin_0(INTERFACE *, sample *, KeySym);
  extern void (*in_out_sample[])(INTERFACE *, sample *, int);
  status=ControlMask;
  sample_subwin_0(i, samp, XK_Insert);
  samp->mode=MOVING;
  in_out_sample[samp->subsubwin](i, samp, UP_3D);
}

void sample_enter_subwin_0_7(INTERFACE *i, sample *samp)
{
  void sample_subwin_0(INTERFACE *, sample *, KeySym);
  extern void (*in_out_sample[])(INTERFACE *, sample *, int);
  status=0;
  sample_subwin_0(i, samp, XK_Insert);
  samp->mode=MOVING;
  in_out_sample[samp->subsubwin](i, samp, UP_3D);
}

void sample_enter_subwin_1_0(INTERFACE *i, sample *samp)
{
  subwin_around_1_0(i, samp, IN);
}

void sample_enter_subwin_1_1(INTERFACE *i, sample *samp)
{
  subwin_around_1_1(i, samp, IN);
}

void sample_enter_subwin_1_2(INTERFACE *i, sample *samp)
{
  extern void (*in_out_sample[])(INTERFACE *, sample *, int);
  samp->mode=MOVING;
  in_out_sample[samp->subsubwin](i, samp, UP_3D);
}

void sample_enter_subwin_1_3(INTERFACE *i, sample *samp)
{
  subwin_around_1_3(i, samp, IN);
}

void record(INTERFACE *i, sample *samp)
{
  extern void (*sample_exit_subwin[3][16])(INTERFACE *, sample *);
  void real_main(INTERFACE *);
  void in_out_sample_1(INTERFACE *, sample *, int);
  char *buf=(char *)0, *new_buf;

  /* we want to see that the button is pushed, so we flush X */
  XFlush(i->X_ecran);

  close_sound();
  if (!open_record(samp->record_rate, samp->record_16b, samp->record_frag_size, samp->record_nb_frags,
		   samp->record_micro_line, samp->record_input_volume)) {
    XBell(i->X_ecran, 0);
    i->in_record=0;
    return;
  }

  i->in_record=1;
  i->record_window=samp->window;
  while(i->in_record) {
    if (!(new_buf=read_record(buf))) {
      i->in_record=0;
      goto end;
    }
    buf=new_buf;
    real_main(i);
  }

end:
  if (i->cut_buffer_in_use)
    free(i->cut_buffer_data);
  i->cut_buffer_in_use=1;
  i->cut_buffer_data=buf;
  i->cut_buffer_type=samp->record_16b;
  i->cut_buffer_length=get_record_buf_size();

  if (!samp->record_16b) {
    char *b=buf;
    int i;
    for (i=0; i<get_record_buf_size(); i++)
      b[i]+=128;
  }

  samp->mode=MOVING;
  sample_exit_subwin[samp->subsubwin][samp->subwindow](i, samp);
  in_out_sample_1(i, samp, UP_3D);

  close_record();
  init_sound(44100, 16, 1);
}

void sample_enter_subwin_1_4(INTERFACE *i, sample *samp)
{
  extern void (*in_out_sample[])(INTERFACE *, sample *, int);
  record(i, samp);
  samp->mode=MOVING;
  in_out_sample[samp->subsubwin](i, samp, UP_3D);
}

void (*sample_enter_subwin[3][16])(INTERFACE *, sample *)={
  {sample_enter_subwin_0, sample_enter_subwin_1, sample_enter_subwin_2, sample_enter_subwin_3,
   sample_enter_subwin_4, sample_enter_subwin_5, sample_enter_subwin_6, sample_enter_subwin_7,
   sample_enter_subwin_0_0, sample_enter_subwin_0_1, sample_enter_subwin_0_2, sample_enter_subwin_0_3,
   sample_enter_subwin_0_4, sample_enter_subwin_0_5, sample_enter_subwin_0_6, sample_enter_subwin_0_7},
  {sample_enter_subwin_0, sample_enter_subwin_1, sample_enter_subwin_2, sample_enter_subwin_3,
   sample_enter_subwin_4, sample_enter_subwin_5, sample_enter_subwin_6, sample_enter_subwin_7,
   sample_enter_subwin_1_0, sample_enter_subwin_1_1, sample_enter_subwin_1_2, sample_enter_subwin_1_3,
   sample_enter_subwin_1_4},
  {sample_enter_subwin_0, sample_enter_subwin_1, sample_enter_subwin_2, sample_enter_subwin_3,
   sample_enter_subwin_4, sample_enter_subwin_5, sample_enter_subwin_6, sample_enter_subwin_7}
};

void draw_back_pos_4(INTERFACE *i, sample *samp)
{
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 4, 128+8+8+13+4, 6*(57-8-5*2)+8, 18, GREY, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 8+8*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 8+19*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 8+(42-8-5)*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, 8+6, 128+8+8+13+4+12,
	      "View :   Sample     Record    Effects", i->little, BLACK);
  redraw_subwin_4(i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context, 4, 128+8+8+13+4, 6*(57-8-5*2)+8, 18, 4, 128+8+8+13+4);
}

void sample_exit_subwin_0(INTERFACE *i, sample *samp)
{
  draw_back_pos_4(i, samp);
}

void sample_exit_subwin_1(INTERFACE *i, sample *samp)
{
}

void sample_exit_subwin_2(INTERFACE *i, sample *samp)
{
}

void sample_exit_subwin_3(INTERFACE *i, sample *samp)
{
}

void sample_exit_subwin_4(INTERFACE *i, sample *samp)
{
  subwin_around_4(i, samp, OUT);
}

void sample_exit_subwin_5(INTERFACE *i, sample *samp)
{
}

void sample_exit_subwin_6(INTERFACE *i, sample *samp)
{
  void redraw_down(INTERFACE *, sample *);
  void around_sub_0(INTERFACE *, sample *, int);
  redraw_down(i, samp);
  around_sub_0(i, samp, IN);
}

void sample_exit_subwin_7(INTERFACE *i, sample *samp)
{
  void redraw_down(INTERFACE *, sample *);
  void around_sub_0(INTERFACE *, sample *, int);
  redraw_down(i, samp);
  around_sub_0(i, samp, IN);
}

void sample_exit_subwin_0_0(INTERFACE *i, sample *samp)
{
  subwin_around_0_0(i, samp, OUT);
}

void sample_exit_subwin_0_1(INTERFACE *i, sample *samp)
{
  subwin_around_0_1(i, samp, OUT);
}

void sample_exit_subwin_0_2(INTERFACE *i, sample *samp)
{
  subwin_around_0_2(i, samp, OUT);
}

void sample_exit_subwin_0_3(INTERFACE *i, sample *samp)
{
  subwin_around_0_3(i, samp, OUT);
}

void sample_exit_subwin_0_4(INTERFACE *i, sample *samp)
{
  subwin_around_0_4(i, samp, OUT);
}

void sample_exit_subwin_0_5(INTERFACE *i, sample *samp)
{
  /* nothing */
}

void sample_exit_subwin_0_6(INTERFACE *i, sample *samp)
{
  /* nothing */
}

void sample_exit_subwin_0_7(INTERFACE *i, sample *samp)
{
  /* nothing */
}

void sample_exit_subwin_1_0(INTERFACE *i, sample *samp)
{
  subwin_around_1_0(i, samp, OUT);
}

void sample_exit_subwin_1_1(INTERFACE *i, sample *samp)
{
  subwin_around_1_1(i, samp, OUT);
}

void sample_exit_subwin_1_2(INTERFACE *i, sample *samp)
{
  /* fuck off for the moment */
}

void sample_exit_subwin_1_3(INTERFACE *i, sample *samp)
{
  subwin_around_1_3(i, samp, OUT);
}

void sample_exit_subwin_1_4(INTERFACE *i, sample *samp)
{
  /* nothing */
}

void (*sample_exit_subwin[3][16])(INTERFACE *, sample *)={
  {sample_exit_subwin_0, sample_exit_subwin_1, sample_exit_subwin_2, sample_exit_subwin_3,
   sample_exit_subwin_4, sample_exit_subwin_5, sample_exit_subwin_6, sample_exit_subwin_7,
   sample_exit_subwin_0_0, sample_exit_subwin_0_1, sample_exit_subwin_0_2, sample_exit_subwin_0_3,
   sample_exit_subwin_0_4, sample_exit_subwin_0_5, sample_exit_subwin_0_6, sample_exit_subwin_0_7},
  {sample_exit_subwin_0, sample_exit_subwin_1, sample_exit_subwin_2, sample_exit_subwin_3,
   sample_exit_subwin_4, sample_exit_subwin_5, sample_exit_subwin_6, sample_exit_subwin_7,
   sample_exit_subwin_1_0, sample_exit_subwin_1_1, sample_exit_subwin_1_2, sample_exit_subwin_1_3,
   sample_exit_subwin_1_4},
  {sample_exit_subwin_0, sample_exit_subwin_1, sample_exit_subwin_2, sample_exit_subwin_3,
   sample_exit_subwin_4, sample_exit_subwin_5, sample_exit_subwin_6, sample_exit_subwin_7}
};

/* this function will put in the center the current position */
void center_sample_view(sample *samp)
{
  unsigned int newval;
  if (samp->cur_pos_0<=256) {
    samp->start_0=0;
    return;
  }
  newval=samp->cur_pos_0-((256ll*samp->inc_0)>>32);
  if (newval>samp->sample_length)
    samp->start_0=0;
  else
    samp->start_0=newval;
}

/* delete the current selection */
void delete_cut(sample *samp)
{
  unsigned long start, end, length;
  char *buf=(char *)samp->sample_data;
  /* step 0 : convert the pos in datum-unit in byte-unit */
  start=samp->sample_type & 16 ? samp->cut_pos_left<<1 : samp->cut_pos_left;
  end=samp->sample_type & 16 ? samp->cut_pos_right<<1 : samp->cut_pos_right;
  length=end-start+(samp->sample_type&16?2:1);

  /* something to cut ? */
  if (!samp->cut_in_use)
    return;

  /* first, copy the end to the new end */
  if (samp->sample_length-end-(samp->sample_type&16?2:1))
    memmove(buf+start, buf+end+(samp->sample_type&16?2:1), samp->sample_length-end-(samp->sample_type&16?2:1));

  samp->cut_in_use=0;
  samp->sample_length-=length;

  /* if 0 length, free */
  if (!samp->sample_length) {
    free(samp->sample_data);
    samp->sample_data=(char *)0;
    samp->sample_loop_start=samp->sample_loop_length=0;
    samp->cur_pos_0=0;
    samp->start_0=0;
    return;
  }

  /* then realloc */
  buf=realloc(buf, samp->sample_length);
  if (!buf) {
    fprintf(stderr, "sub_sample.delete_cut BIG PROBLEMS ! save all you can, quit and re-run. hope it won't core dump,"
	    "but nothing is sure anymore.\n");
    /* shitty return, should handle this error better */
    return;
  }

  samp->sample_data=buf;

  samp->cur_pos_0=samp->cut_pos_left;
  if (samp->cur_pos_0>=samp->sample_length>>(samp->sample_type&16?1:0))
    samp->cur_pos_0--;

  /* wonderfuls if-then-else !! */
  if (samp->sample_loop_start+samp->sample_loop_length>=start)
    if (samp->sample_loop_start+samp->sample_loop_length<=end)
      /* you cut it ? damned shit you are ! 0 length to punish you. Nah. */
      samp->sample_loop_length=0;
    else
      /* if loop_start is before the end of the cut region, then, make simple : 0 length
       * (too late to make subtile things)
       */
      if (samp->sample_loop_start<=end)
	samp->sample_loop_length=0;

  if (samp->sample_loop_start>=start)
    if (samp->sample_loop_start<=end)
      /* not what i want, but if you cut a buffer where sample loop start is, you are a fool, huh ? */
      if (!start)
	samp->sample_loop_start=0;
      else
	samp->sample_loop_start=start-(samp->sample_type&16?2:1);
    else
      samp->sample_loop_start-=length;

  /* max_inc_0 must be recalculated */
  samp->max_inc_0=samp->sample_length;
  if (samp->sample_type&16)
    samp->max_inc_0>>=1;
  if (samp->max_inc_0<512)
    samp->max_inc_0=512;
  samp->inc_0=((unsigned long long)samp->max_inc_0)<<(32-9);
}

/* insert cut buffer at current pos and selection becomes just what was inserted */
void insert_cut(INTERFACE *i, sample *samp)
{
  unsigned long newinc, curpos, length;
  char *dum;

  /* checking */
  if (!i->cut_buffer_in_use)
    return;
  if (samp->cut_in_use)
    return;

  /* if destination is void, we give a type that matches with the source */
  if (!samp->sample_length)
    samp->sample_type|=i->cut_buffer_type?16:0;

  /* calculate new size of destination (take care of 8/16b) */
  if (samp->sample_type&16)
    newinc=i->cut_buffer_type ? i->cut_buffer_length : i->cut_buffer_length<<1;
  else
    newinc=i->cut_buffer_type ? i->cut_buffer_length>>1 : i->cut_buffer_length;

  dum=realloc(samp->sample_data, samp->sample_length+newinc);
  if (!dum) {
    fprintf(stderr, "sub_sample.insert_cut error with realloc\n");
    return;
  }
  samp->sample_data=dum;
  curpos=samp->sample_type&16 ? samp->cur_pos_0<<1 : samp->cur_pos_0;
  length=samp->sample_length-curpos;
  samp->sample_length+=newinc;

  /* now move the sample so we have the hole where we then will put the new data */
  if (length)
    memmove(dum+curpos+newinc, dum+curpos, length);

  /* make the copy-stuff to be the selection */
  samp->cut_in_use=1;
  samp->cut_pos_left=curpos;
  samp->cut_pos_right=curpos+newinc-1;
  if (samp->sample_type&16) {
    samp->cut_pos_left>>=1;
    samp->cut_pos_right>>=1;
  }
  samp->cur_pos_0=samp->cut_pos_right;
  samp->cur_cut_pos=1;

  /* now copy data. 8 or 16b in dest and 8 or 16b in source makes 4 cases */
  if (samp->sample_type&16) {
    if (i->cut_buffer_type) {
      /* 16b -> 16b */
      short *src=(short *)(i->cut_buffer_data);
      short *dest=(short *)(dum+curpos);
      newinc>>=1;
      for (;newinc>0; newinc--)
	*dest++=*src++;
    } else {
      /* 8b -> 16b */
      char *src=(char *)(i->cut_buffer_data);
      short *dest=(short *)(dum+curpos);
      newinc>>=1;
      for (;newinc>0; newinc--)
	*dest++=((short)(*src++))<<8;
    }
  } else {
    if (i->cut_buffer_type) {
      /* 16b -> 8b */
      short *src=(short *)(i->cut_buffer_data);
      char *dest=(char *)(dum+curpos);
      for (;newinc>0; newinc--)
	*dest++=(char)((*src++)>>8);
    } else {
      /* 8b -> 8b */
      char *src=(char *)(i->cut_buffer_data);
      char *dest=(char *)(dum+curpos);
      for (;newinc>0; newinc--)
	*dest++=*src++;
    }
  }

  /* max_inc_0 must be recalculated */
  samp->max_inc_0=samp->sample_length;
  if (samp->sample_type&16)
    samp->max_inc_0>>=1;
  if (samp->max_inc_0<512)
    samp->max_inc_0=512;
  samp->inc_0=((unsigned long long)samp->max_inc_0)<<(32-9);
}

/* copy the current selection in the cut-buffer (delete previous cut-buffer) */
void copy_cut(INTERFACE *i, sample *samp)
{
  unsigned long size;

  /* if cut buffer, free it first */
  if (i->cut_buffer_in_use)
    free(i->cut_buffer_data);

  size=samp->cut_pos_right-samp->cut_pos_left+1;
  if (samp->sample_type&16)
    size<<=1;

  /* alloc the mem */
  if (!(i->cut_buffer_data=(char *)malloc(size))) {
    i->cut_buffer_in_use=0;
    fprintf(stderr, "sub_sample.copy_cut error with malloc\n");
    return;
  }
  
  /* copy things */
  memmove(i->cut_buffer_data, samp->sample_data+(samp->sample_type&16?samp->cut_pos_left<<1:samp->cut_pos_left), size);

  /* ok, now put the type and length */
  i->cut_buffer_type=samp->sample_type&16 ? 1 : 0;
  i->cut_buffer_length=size;
  i->cut_buffer_in_use=1;
}

void sample_subwin_0(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks+(status<<16)) {
    /* moving the cursor */
    case XK_Right :
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0>=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0<samp->start_0 || samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	center_sample_view(samp);
      samp->cur_pos_0+=samp->inc_0>>32;
      if (samp->cur_pos_0>(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1)
	samp->cur_pos_0=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1;
      if (samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	samp->start_0+=samp->inc_0>>32;
      samp->cut_in_use=0;
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    case XK_Left : {
      unsigned long newval;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0<samp->start_0 || samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	center_sample_view(samp);
      newval=samp->cur_pos_0-(samp->inc_0>>32);
      if (newval>samp->cur_pos_0)
	samp->cur_pos_0=0;
      else
	samp->cur_pos_0=newval;
      if (samp->cur_pos_0<samp->start_0) {
	newval=samp->start_0-(samp->inc_0>>32);
	if (newval>samp->start_0)
	  samp->start_0=0;
	else
	  samp->start_0=newval;
      }
      samp->cut_in_use=0;
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    }
    case XK_Tab :
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      /* if we have a selection, then we change the moving point */
      if (samp->cut_in_use) {
	samp->cur_cut_pos^=1;
	samp->cur_pos_0=samp->cur_cut_pos ? samp->cut_pos_right : samp->cut_pos_left;
	center_sample_view(samp);
	redraw_sample(i, samp);
	break;
      }
      if (samp->cur_pos_0>=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0<samp->start_0 || samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	center_sample_view(samp);
      samp->cur_pos_0+=(samp->inc_0*16)>>32;
      if (samp->cur_pos_0>(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1)
	samp->cur_pos_0=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1;
      if (samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	samp->start_0+=(samp->inc_0*16)>>32;
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    case XK_Tab+(ControlMask<<16) : {
      unsigned long newval;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cut_in_use) {
	samp->cur_cut_pos^=1;
	samp->cur_pos_0=samp->cur_cut_pos ? samp->cut_pos_right : samp->cut_pos_left;
	center_sample_view(samp);
	redraw_sample(i, samp);
	break;
      }
      if (samp->cur_pos_0==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0<samp->start_0 || samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	center_sample_view(samp);
      newval=samp->cur_pos_0-((samp->inc_0*16)>>32);
      if (newval>samp->cur_pos_0)
	samp->cur_pos_0=0;
      else
	samp->cur_pos_0=newval;
      if (samp->cur_pos_0<samp->start_0) {
	newval=samp->start_0-((samp->inc_0*16)>>32);
	if (newval>samp->start_0)
	  samp->start_0=0;
	else
	  samp->start_0=newval;
      }
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    }
    case XK_Home :
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      samp->cut_in_use=0;
      samp->cur_pos_0=0;
      center_sample_view(samp);
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    case XK_End :
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0==(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      samp->cut_in_use=0;
      samp->cur_pos_0=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1;
      center_sample_view(samp);
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    /* making a selection (same as moving, but dealing with the selection) */
    case XK_Right+(ShiftMask<<16) : {
      int oldpos=samp->cur_pos_0;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0>=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0<samp->start_0 || samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	center_sample_view(samp);
      samp->cur_pos_0+=samp->inc_0>>32;
      if (samp->cur_pos_0>(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1)
	samp->cur_pos_0=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1;
      if (samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	samp->start_0+=samp->inc_0>>32;
      if (!samp->cut_in_use) {
	samp->cut_in_use++;
	samp->cut_pos_left=oldpos;
	samp->cut_pos_right=samp->cur_pos_0;
	samp->cur_cut_pos=1;
      } else
	if (samp->cur_cut_pos)
	  samp->cut_pos_right=samp->cur_pos_0;
	else
	  samp->cut_pos_left=samp->cur_pos_0;
      /* maybe left has become right and vice-versa */
      if (samp->cut_pos_left>samp->cut_pos_right) {
	unsigned long dum;
	dum=samp->cut_pos_left;
	samp->cut_pos_left=samp->cut_pos_right;
	samp->cut_pos_right=dum;
	samp->cur_cut_pos=1;
      }
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    }
    case XK_Left+(ShiftMask<<16) : {
      unsigned long newval, oldpos=samp->cur_pos_0;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0<samp->start_0 || samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	center_sample_view(samp);
      newval=samp->cur_pos_0-(samp->inc_0>>32);
      if (newval>samp->cur_pos_0)
	samp->cur_pos_0=0;
      else
	samp->cur_pos_0=newval;
      if (samp->cur_pos_0<samp->start_0) {
	newval=samp->start_0-(samp->inc_0>>32);
	if (newval>samp->start_0)
	  samp->start_0=0;
	else
	  samp->start_0=newval;
      }
      if (!samp->cut_in_use) {
	samp->cut_in_use++;
	samp->cut_pos_right=oldpos;
	samp->cut_pos_left=samp->cur_pos_0;
	samp->cur_cut_pos=0;
      } else
	if (samp->cur_cut_pos)
	  samp->cut_pos_right=samp->cur_pos_0;
	else
	  samp->cut_pos_left=samp->cur_pos_0;
      if (samp->cut_pos_left>samp->cut_pos_right) {
	unsigned long dum;
	dum=samp->cut_pos_left;
	samp->cut_pos_left=samp->cut_pos_right;
	samp->cut_pos_right=dum;
	samp->cur_cut_pos=0;
      }
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    }
    case XK_Tab+(ShiftMask<<16) : {
      unsigned long oldpos=samp->cur_pos_0;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0>=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0<samp->start_0 || samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	center_sample_view(samp);
      samp->cur_pos_0+=(samp->inc_0*16)>>32;
      if (samp->cur_pos_0>(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1)
	samp->cur_pos_0=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1;
      if (samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	samp->start_0+=(samp->inc_0*16)>>32;
      if (!samp->cut_in_use) {
	samp->cut_in_use++;
	samp->cut_pos_left=oldpos;
	samp->cut_pos_right=samp->cur_pos_0;
	samp->cur_cut_pos=1;
      } else
	if (samp->cur_cut_pos)
	  samp->cut_pos_right=samp->cur_pos_0;
	else
	  samp->cut_pos_left=samp->cur_pos_0;
      if (samp->cut_pos_left>samp->cut_pos_right) {
	unsigned long dum;
	dum=samp->cut_pos_left;
	samp->cut_pos_left=samp->cut_pos_right;
	samp->cut_pos_right=dum;
	samp->cur_cut_pos=1;
      }
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    }
    case XK_Tab+((ControlMask|ShiftMask)<<16) : {
      unsigned long newval, oldpos=samp->cur_pos_0;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0<samp->start_0 || samp->cur_pos_0>=samp->start_0+((512ll*samp->inc_0)>>32))
	center_sample_view(samp);
      newval=samp->cur_pos_0-((samp->inc_0*16)>>32);
      if (newval>samp->cur_pos_0)
	samp->cur_pos_0=0;
      else
	samp->cur_pos_0=newval;
      if (samp->cur_pos_0<samp->start_0) {
	newval=samp->start_0-((samp->inc_0*16)>>32);
	if (newval>samp->start_0)
	  samp->start_0=0;
	else
	  samp->start_0=newval;
      }
      if (!samp->cut_in_use) {
	samp->cut_in_use++;
	samp->cut_pos_right=oldpos;
	samp->cut_pos_left=samp->cur_pos_0;
	samp->cur_cut_pos=0;
      } else
	if (samp->cur_cut_pos)
	  samp->cut_pos_right=samp->cur_pos_0;
	else
	  samp->cut_pos_left=samp->cur_pos_0;
      if (samp->cut_pos_left>samp->cut_pos_right) {
	unsigned long dum;
	dum=samp->cut_pos_left;
	samp->cut_pos_left=samp->cut_pos_right;
	samp->cut_pos_right=dum;
	samp->cur_cut_pos=0;
      }
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    }
    case XK_Home+(ShiftMask<<16) : {
      unsigned long oldpos=samp->cur_pos_0;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      samp->cur_pos_0=0;
      center_sample_view(samp);
      if (!samp->cut_in_use) {
	samp->cut_in_use++;
	samp->cut_pos_right=oldpos;
	samp->cut_pos_left=samp->cur_pos_0;
	samp->cur_cut_pos=0;
      } else
	if (samp->cur_cut_pos)
	  samp->cut_pos_right=samp->cur_pos_0;
	else
	  samp->cut_pos_left=samp->cur_pos_0;
      if (samp->cut_pos_left>samp->cut_pos_right) {
	unsigned long dum;
	dum=samp->cut_pos_left;
	samp->cut_pos_left=samp->cut_pos_right;
	samp->cut_pos_right=dum;
	samp->cur_cut_pos=0;
      }
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    }
    case XK_End+(ShiftMask<<16) : {
      unsigned long oldpos=samp->cur_pos_0;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->cur_pos_0==(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      samp->cur_pos_0=(samp->sample_type & 16 ? samp->sample_length>>1: samp->sample_length)-1;
      center_sample_view(samp);
      if (!samp->cut_in_use) {
	samp->cut_in_use++;
	samp->cut_pos_left=oldpos;
	samp->cut_pos_right=samp->cur_pos_0;
	samp->cur_cut_pos=1;
      } else
	if (samp->cur_cut_pos)
	  samp->cut_pos_right=samp->cur_pos_0;
	else
	  samp->cut_pos_left=samp->cur_pos_0;
      if (samp->cut_pos_left>samp->cut_pos_right) {
	unsigned long dum;
	dum=samp->cut_pos_left;
	samp->cut_pos_left=samp->cut_pos_right;
	samp->cut_pos_right=dum;
	samp->cur_cut_pos=1;
      }
      redraw_sample(i, samp);
      display_cur_pos_0(i, samp);
      break;
    }
    /* set loop start/end */
    case XK_l :		/* put loop start */
    case XK_L : {
      unsigned long pos=samp->cur_pos_0*(samp->sample_type&16?2:1);
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (pos==samp->sample_loop_start) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (pos>=samp->sample_loop_start+samp->sample_loop_length)
	samp->sample_loop_length=0;
      else
	samp->sample_loop_length+=samp->sample_loop_start-pos;
      samp->sample_loop_start=pos;
      redraw_sample(i, samp);
      redraw_loop_start(i, samp);
      redraw_loop_end(i, samp);
      break;
    }
    case XK_e :		/* put loop end */
    case XK_E : {
      unsigned long pos=samp->cur_pos_0*(samp->sample_type&16?2:1);
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (pos<samp->sample_loop_start) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->sample_loop_length==pos-samp->sample_loop_start) {
	XBell(i->X_ecran, 0);
	break;
      }
      samp->sample_loop_length=pos-samp->sample_loop_start;
      redraw_sample(i, samp);
      redraw_loop_start(i, samp);
      redraw_loop_end(i, samp);
      break;
    }
    /* zoom in/out */
    case XK_plus : {	/* zoom in */
      unsigned long size;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->max_inc_0==512) {
	XBell(i->X_ecran, 0);
	break;
      }
      size=samp->sample_length>>(samp->sample_type&16?1:0);
      samp->max_inc_0-=samp->max_inc_0>>4?samp->max_inc_0>>4:1;
      if (samp->max_inc_0<512 || samp->max_inc_0>size)
	samp->max_inc_0=512;
      samp->inc_0=((unsigned long long)samp->max_inc_0)<<(32-9);
      /* test useless, but i prefer useless tests than unwanted bugs */
      if (samp->inc_0<=1ll<<32)
	samp->inc_0=1ll<<32;
      center_sample_view(samp);
      redraw_sample(i, samp);
      break;
    }
    case XK_minus : {	/* zoom out */
      unsigned long size;
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (samp->max_inc_0==samp->sample_length>>(samp->sample_type&16?1:0)) {
	XBell(i->X_ecran, 0);
	break;
      }
      size=samp->sample_length>>(samp->sample_type&16?1:0);
      samp->max_inc_0+=samp->max_inc_0>>4?samp->max_inc_0>>4:1;
      if (samp->max_inc_0>size /* this || should not be there, but we never know... */ ||
	  samp->max_inc_0<512)
	samp->max_inc_0=size;
      samp->inc_0=((unsigned long long)samp->max_inc_0)<<(32-9);
      /* once again, useless test... */
      if(samp->inc_0<1ll<<32)
	samp->inc_0=1ll<<32;
      center_sample_view(samp);
      redraw_sample(i, samp);
      break;
    }
    /* dealing with the global cut-buffer */
    case XK_Insert :
    case XK_Insert+(ShiftMask<<16) :
      if (!i->cut_buffer_in_use) {
	XBell(i->X_ecran, 0);
	break;
      }
      delete_cut(samp);
      insert_cut(i, samp);
      center_sample_view(samp);
      redraw_sample(i, samp);
      redraw_loop_start(i, samp);
      redraw_loop_end(i, samp);
      redraw_sample_size(i, samp);
      redraw_8_16_bits(i, samp);
      display_cur_pos_0(i, samp);
      break;
    case XK_Insert+(ControlMask<<16) :
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (!samp->cut_in_use) {
	XBell(i->X_ecran, 0);
	break;
      }
      copy_cut(i, samp);
      break;
    case XK_Delete :
    case XK_Delete+(ShiftMask<<16) :
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (!samp->cut_in_use) {
	XBell(i->X_ecran, 0);
	break;
      }
      copy_cut(i, samp);
      delete_cut(samp);
      center_sample_view(samp);
      redraw_sample(i, samp);
      redraw_loop_start(i, samp);
      redraw_loop_end(i, samp);
      redraw_sample_size(i, samp);
      redraw_8_16_bits(i, samp);
      display_cur_pos_0(i, samp);
      break;
    case XK_Delete+(ControlMask<<16) :
      if (samp->sample_length==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      if (!samp->cut_in_use) {
	XBell(i->X_ecran, 0);
	break;
      }
      delete_cut(samp);
      center_sample_view(samp);
      redraw_sample(i, samp);
      redraw_loop_start(i, samp);
      redraw_loop_end(i, samp);
      redraw_sample_size(i, samp);
      redraw_8_16_bits(i, samp);
      display_cur_pos_0(i, samp);
      break;
  }
}

void sample_subwin_1(INTERFACE *i, sample *samp, KeySym ks)
{
}

void sample_subwin_2(INTERFACE *i, sample *samp, KeySym ks)
{
}

void sample_subwin_3(INTERFACE *i, sample *samp, KeySym ks)
{
}

extern void (*init_view[3])(INTERFACE *, sample *);
extern void (*draw_view[3])(INTERFACE *, sample *);

void redraw_down(INTERFACE *i, sample *samp)
{
  draw_box(i->X_ecran, samp->pixmap, i->context, 4, YI+5, LARGEUR-8, HAUTEUR-4-(YI+5), BLACK);
  init_view[samp->subsubwin](i, samp);
  draw_view[samp->subsubwin](i, samp);
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context, 4, YI+5, LARGEUR-8, HAUTEUR-4-(YI+5), 4, YI+5);
}

void sample_subwin_4(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      if (samp->subsubwin==samp->cur_pos_4)
	break;
      samp->subsubwin=samp->cur_pos_4;
      redraw_subwin_4(i, samp);
      redraw_down(i, samp);
      break;
    case XK_Left :
      sample_exit_subwin_4(i, samp);
      samp->cur_pos_4--;
      if (samp->cur_pos_4<0)
	samp->cur_pos_4=2;
      sample_enter_subwin_4(i, samp);
      break;
    case XK_Right :
      sample_exit_subwin_4(i, samp);
      samp->cur_pos_4++;
      if (samp->cur_pos_4>2)
	samp->cur_pos_4=0;
      sample_enter_subwin_4(i, samp);
      break;
  }
}

void sample_subwin_5(INTERFACE *i, sample *samp, KeySym ks)
{
}

void sample_subwin_6(INTERFACE *i, sample *samp, KeySym ks)
{
  void in_out_sample_0(INTERFACE *, sample *, int);
  int (*load[2])(sample *, char *)={
    load_wav, load_raw
  };
  switch(ks) {
    case XK_Return :
    case XK_space :
      if (init_file_selector(i, ".") && i->file_selector.out_name) {
	if (!load[samp->cur_pos_6](samp, i->file_selector.out_name))
	  fprintf(stderr, "sub_sample.sample_subwin_6 error with loading %s\n", i->file_selector.out_name);
	else {
	  extern XM *the_xm;	/* hey ! i need the xm of a sample, damned. */
	  void draw_sample_all_lines(INTERFACE *i, XM *xm);
	  draw_sample_all_lines(i, the_xm);
	  redraw_sample(i, samp);
	  redraw_sample_size(i, samp);
	}
      } else
	fprintf(stderr, "sub_sample.sample_subwin_6 could not deal with file selector\n");
      samp->mode=MOVING;
      sample_exit_subwin_6(i, samp);
      in_out_sample_0(i, samp, UP_3D);
      break;
    case XK_Up :
    case XK_Down :
      samp->cur_pos_6++;
      samp->cur_pos_6&=1;
      draw_pos_6(i, samp);
      break;
  }
}

void sample_subwin_7(INTERFACE *i, sample *samp, KeySym ks)
{
  void in_out_sample_0(INTERFACE *, sample *, int);

  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(samp->cur_pos_7) {
	case 0 : { /* rate ++ */
	  int inc=1;
	  if (samp->rate_7==99999) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    inc=10;
	  if (status==ControlMask)
	    inc=100;
	  if (status==(ShiftMask|ControlMask))
	    inc=1000;
	  if (status==Mod1Mask)
	    inc=10000;
	  samp->rate_7+=inc;
	  if (samp->rate_7>99999)
	    samp->rate_7=99999;
	  draw_pos_7(i, samp);
	  break;
	}
	case 1 : { /* rate -- */
	  int dec=1;
	  if (samp->rate_7==1) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=10;
	  if (status==ControlMask)
	    dec=100;
	  if (status==(ShiftMask|ControlMask))
	    dec=1000;
	  if (status==Mod1Mask)
	    dec=10000;
	  samp->rate_7-=dec;
	  if (samp->rate_7<1)
	    samp->rate_7=1;
	  draw_pos_7(i, samp);
	  break;
	}
	case 2 :
	  if (init_file_selector(i, "."))
	    if (!save_wav(samp, i->file_selector.out_name, samp->rate_7))
	      fprintf(stderr, "sub_sample.sample_subwin_7 error in saving the wav\n");
	  sample_exit_subwin_7(i, samp);
	  samp->mode=MOVING;
	  in_out_sample_0(i, samp, UP_3D);
	  break;
	case 3 : /* cancel */
	  sample_exit_subwin_7(i, samp);
	  samp->mode=MOVING;
	  in_out_sample_0(i, samp, UP_3D);
	  break;
      }
      break;
    case XK_Down :
      around_7(i, samp, OUT);
      samp->cur_pos_7++;
      samp->cur_pos_7&=3;
      around_7(i, samp, IN);
      break;
    case XK_Up :
      around_7(i, samp, OUT);
      samp->cur_pos_7--;
      samp->cur_pos_7&=3;
      around_7(i, samp, IN);
      break;
    case XK_Right :
    case XK_Left :
      if (samp->cur_pos_7<2)
	break;
      around_7(i, samp, OUT);
      samp->cur_pos_7=samp->cur_pos_7==2?3:2;
      around_7(i, samp, IN);
      break;
  }
}

void sample_subwin_0_0(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      if (!samp->sample_length) {
	XBell(i->X_ecran, 0);
	break;
      }
      switch(samp->cur_pos_0_0) {
	case 0 : {	/* loop start ++ */
	  unsigned long old=samp->sample_loop_start;
	  unsigned long inc=1, newlen;
	  if (old>=samp->sample_length-(samp->sample_type&16?2:1)) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  /* lovely "else" cascad */
	  if (status==ShiftMask)
	    inc=0x10;
	  else if (status==ControlMask)
	    inc=0x100;
	  else if (status==(ShiftMask|ControlMask)) /* if not between ( and ), gcc will warning */
	    inc=0x1000;
	  else if (status==Mod1Mask)
	    inc=0x10000;
	  else if (status==(Mod1Mask|ShiftMask))
	    inc=0x100000;
	  else if (status==(Mod1Mask|ControlMask))
	    inc=0x1000000;
	  else if (status==(Mod1Mask|ShiftMask|ControlMask))
	    inc=0x10000000;
	  if (samp->sample_type&16)
	    inc<<=1;
	  samp->sample_loop_start+=inc;
	  if (samp->sample_loop_start>=samp->sample_length)
	    samp->sample_loop_start=samp->sample_length-(samp->sample_type&16?2:1);
	  /* because of this shitty sample loop length instead of sample loop end (more logical and easier to use)
	   * we have to modify it. Not big troubles, but bug generation knows no limits.
	   */
	  newlen=samp->sample_loop_length-(samp->sample_loop_start-old);
	  if (newlen>samp->sample_loop_length)		/* because of unsigned, we gotta test overflow this way */
	    newlen=0;
	  samp->sample_loop_length=newlen;
	  redraw_loop_start(i, samp);
	  redraw_loop_end(i, samp);
	  redraw_sample(i, samp);
	  break;
	}
	case 1 : {	/* loop start -- */
	  unsigned long old=samp->sample_loop_start;
	  unsigned long dec=1;
	  if (old==0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=0x10;
	  if (status==ControlMask)
	    dec=0x100;
	  if (status==(ShiftMask|ControlMask))
	    dec=0x1000;
	  else if (status==Mod1Mask)
	    dec=0x10000;
	  else if (status==(Mod1Mask|ShiftMask))
	    dec=0x100000;
	  else if (status==(Mod1Mask|ControlMask))
	    dec=0x1000000;
	  else if (status==(Mod1Mask|ShiftMask|ControlMask))
	    dec=0x10000000;
	  if (samp->sample_type&16)
	    dec<<=1;
	  samp->sample_loop_start-=dec;
	  if (samp->sample_loop_start>old)
	    samp->sample_loop_start=0;
	  samp->sample_loop_length+=old-samp->sample_loop_start;
	  redraw_loop_start(i, samp);
	  redraw_loop_end(i, samp);
	  redraw_sample(i, samp);
	  break;
	}
	case 2 : { /* loop end ++ */
	  unsigned long inc=1;
	  if (samp->sample_loop_start+samp->sample_loop_length>=samp->sample_length) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    inc=0x10;
	  else if (status==ControlMask)
	    inc=0x100;
	  else if (status==(ShiftMask|ControlMask))
	    inc=0x1000;
	  else if (status==Mod1Mask)
	    inc=0x10000;
	  else if (status==(Mod1Mask|ShiftMask))
	    inc=0x100000;
	  else if (status==(Mod1Mask|ControlMask))
	    inc=0x1000000;
	  else if (status==(Mod1Mask|ShiftMask|ControlMask))
	    inc=0x10000000;
	  if (samp->sample_type&16)
	    inc<<=1;
	  samp->sample_loop_length+=inc;
	  if (samp->sample_loop_start+samp->sample_loop_length>samp->sample_length)
	    samp->sample_loop_length=samp->sample_length-samp->sample_loop_start;
	  redraw_loop_start(i, samp);
	  redraw_loop_end(i, samp);
	  redraw_sample(i, samp);
	  break;
	}
	case 3 : { /* loop end -- */
	  unsigned long dec=1, old=samp->sample_loop_length;
	  if (!old) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=0x10;
	  else if (status==ControlMask)
	    dec=0x100;
	  else if (status==(ShiftMask|ControlMask))
	    dec=0x1000;
	  else if (status==Mod1Mask)
	    dec=0x10000;
	  else if (status==(Mod1Mask|ShiftMask))
	    dec=0x100000;
	  else if (status==(Mod1Mask|ControlMask))
	    dec=0x1000000;
	  else if (status==(Mod1Mask|ShiftMask|ControlMask))
	    dec=0x10000000;
	  if (samp->sample_type&16)
	    dec<<=1;
	  samp->sample_loop_length-=dec;
	  if (samp->sample_loop_length>old)
	    samp->sample_loop_length=0;
	  redraw_loop_start(i, samp);
	  redraw_loop_end(i, samp);
	  redraw_sample(i, samp);
	  break;
	}
      }
      break;
    case XK_Down :
      sample_exit_subwin_0_0(i, samp);
      samp->cur_pos_0_0++;
      samp->cur_pos_0_0&=3;
      sample_enter_subwin_0_0(i, samp);
      break;
    case XK_Up :
      sample_exit_subwin_0_0(i, samp);
      samp->cur_pos_0_0--;
      samp->cur_pos_0_0&=3;
      sample_enter_subwin_0_0(i, samp);
      break;
  }
}

void sample_subwin_0_1(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(samp->cur_pos_0_1) {
	case 0 : { /* fine tune ++ */
	  char inc=1, old=samp->sample_fine_tune;
	  if (old>=127) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  /* no funny else here, some change don't make bad (except when it generates new bugs) */
	  if (status==ShiftMask)
	    inc=10;
	  if (status==ControlMask)
	    inc=100;
	  samp->sample_fine_tune+=inc;
	  if (samp->sample_fine_tune<old)
	    samp->sample_fine_tune=127;
	  redraw_fine_tune(i, samp);
	  break;
	}
	case 1 : { /* fine tune -- */
	  char dec=1, old=samp->sample_fine_tune;
	  if (old<=-128) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=10;
	  if (status==ControlMask)
	    dec=100;
	  samp->sample_fine_tune-=dec;
	  if (samp->sample_fine_tune>old)
	    samp->sample_fine_tune=-128;
	  redraw_fine_tune(i, samp);
	  break;
	}
	case 2 : { /* relative tone ++ */
	  char inc=1, old=samp->sample_relative_note_number;
	  if (old>=71) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    inc=12;
	  samp->sample_relative_note_number+=inc;
	  if (samp->sample_relative_note_number<old || samp->sample_relative_note_number>71)
	    samp->sample_relative_note_number=71;
	  redraw_relative_tone(i, samp);
	  break;
	}
	case 3 : { /* relative tone -- */
	  char dec=1, old=samp->sample_relative_note_number;
	  if (old<=-48) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=12;
	  samp->sample_relative_note_number-=dec;
	  if (samp->sample_relative_note_number>old || samp->sample_relative_note_number<-48)
	    samp->sample_relative_note_number=-48;
	  redraw_relative_tone(i, samp);
	  break;
	}
      }
      break;
    case XK_Down :
      sample_exit_subwin_0_1(i, samp);
      samp->cur_pos_0_1++;
      samp->cur_pos_0_1&=3;
      sample_enter_subwin_0_1(i, samp);
      break;
    case XK_Up :
      sample_exit_subwin_0_1(i, samp);
      samp->cur_pos_0_1--;
      samp->cur_pos_0_1&=3;
      sample_enter_subwin_0_1(i, samp);
      break;
  }
}

void sample_subwin_0_2(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(samp->cur_pos_0_2) {
	case 0 : { /* volume ++ */
	  char inc=1;
	  if (samp->sample_volume>=0x40) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    inc=0x10;
	  samp->sample_volume+=inc;
	  if (samp->sample_volume>0x40)
	    samp->sample_volume=0x40;
	  redraw_volume(i, samp);
	  break;
	}
	case 1 : { /* volume -- */
	  char dec=1;
	  if (samp->sample_volume<=0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=0x10;
	  samp->sample_volume-=dec;
	  if (samp->sample_volume<0)
	    samp->sample_volume=0;
	  redraw_volume(i, samp);
	  break;
	}
	case 2 : { /* panning ++ */
	  unsigned char inc=1, old=samp->sample_panning;
	  if (old>=0xff) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    inc=0x10;
	  samp->sample_panning+=inc;
	  if (samp->sample_panning<old)
	    samp->sample_panning=0xff;
	  redraw_panning(i, samp);
	  break;
	}
	case 3 : { /* panning -- */
	  unsigned char dec=1, old=samp->sample_panning;
	  if (old<=0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=0x10;
	  samp->sample_panning-=dec;
	  if (samp->sample_panning>old)
	    samp->sample_panning=0;
	  redraw_panning(i, samp);
	  break;
	}
      }
      break;
    case XK_Down :
      sample_exit_subwin_0_2(i, samp);
      samp->cur_pos_0_2++;
      samp->cur_pos_0_2&=3;
      sample_enter_subwin_0_2(i, samp);
      break;
    case XK_Up :
      sample_exit_subwin_0_2(i, samp);
      samp->cur_pos_0_2--;
      samp->cur_pos_0_2&=3;
      sample_enter_subwin_0_2(i, samp);
      break;
  }
}

void sample_subwin_0_3(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(samp->cur_pos_0_3) {
	case 0 : /* becomes 8b */
	  if (!(samp->sample_type&16) || !samp->sample_length) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  samp->sample_type&=~16;
	  redraw_8_16_bits(i, samp);
	  samp->sample_type&=~3;	/* no loop anymore */
	  redraw_use_loop(i, samp);
	  samp->max_inc_0=samp->sample_length;
	  if (samp->max_inc_0<512)
	    samp->max_inc_0=512;
	  samp->inc_0=(unsigned long long)samp->max_inc_0<<(32-9);
	  samp->start_0=0;
	  samp->cur_pos_0=0;
	  samp->cut_in_use=0;
	  if (!samp->mode_3_0) {
	    redraw_sample(i, samp);
	    break;
	  }
	  { /* ok, let's convert it. */
	    short *src=(short *)samp->sample_data;
	    char *dest=samp->sample_data;
	    int j;
	    for(j=samp->sample_length/2; j>0; j--)
	      *dest++=(*src++)>>8;
	    samp->sample_length>>=1;
	    redraw_sample_size(i, samp);
	    samp->max_inc_0=samp->sample_length;
	    if (samp->max_inc_0<512)
	      samp->max_inc_0=512;
	    samp->inc_0=(unsigned long long)samp->max_inc_0<<(32-9);
	    redraw_sample(i, samp);
	    if (!(dest=realloc(samp->sample_data, samp->sample_length))) {
	      fprintf(stderr, "sub_sample.sample_subwin_0_3 error with realloc, sorry but data corrupted\n");
	      break;
	    }
	    samp->sample_data=dest;
	  }
	  break;
	case 1 : /* becomes 16b */
	  if (samp->sample_type&16) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (!samp->sample_length || (samp->sample_length==1 && !samp->mode_3_0)) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  samp->sample_type|=16;
	  redraw_8_16_bits(i, samp);
	  samp->sample_type&=~3;
	  redraw_use_loop(i, samp);
	  samp->max_inc_0=samp->sample_length>>1;
	  if (samp->max_inc_0<512)
	    samp->max_inc_0=512;
	  samp->inc_0=(unsigned long long)samp->max_inc_0<<(32-9);
	  samp->start_0=0;
	  samp->cur_pos_0=0;
	  samp->cut_in_use=0;
	  if (!samp->mode_3_0) {
	    char *dum;
	    if (samp->sample_length&1) {
	      samp->sample_length&=~1;
	      if (!(dum=realloc(samp->sample_data, samp->sample_length))) {
		fprintf(stderr, "sun_sample.sample_subwin_0_3 error with realloc, you should stop the prog now !\n");
		/* bad error handling, huh ? */
		break;
	      }
	      samp->sample_data=dum;
	      redraw_sample_size(i, samp);
	      samp->max_inc_0=samp->sample_length>>1;
	      if (samp->max_inc_0<512)
		samp->max_inc_0=512;
	      samp->inc_0=(unsigned long long)samp->max_inc_0<<(32-9);
	    }
	    redraw_sample(i, samp);
	    break;
	  }
	  { /* ok, let's convert it. 8->16b */
	    short *dest;
	    char *src;
	    int j;

	    if (!(src=realloc(samp->sample_data, samp->sample_length<<1))) {
	      fprintf(stderr, "sub_sample.sample_subwin_0_3 error with realloc, sorry pal. You should stop it all\n");
	      break;
	    }
	    samp->sample_length<<=1;
	    redraw_sample_size(i, samp);
	    samp->sample_data=src;

	    dest=(short *)(samp->sample_data+samp->sample_length-2);
	    src=samp->sample_data+samp->sample_length/2-1;

	    for(j=samp->sample_length>>1; j>0; j--)
	      *dest--=(*src--)<<8;
	    samp->max_inc_0=samp->sample_length>>1;
	    if (samp->max_inc_0<512)
	      samp->max_inc_0=512;
	    samp->inc_0=(unsigned long long)samp->max_inc_0<<(32-9);
	    redraw_sample(i, samp);
	  }
	  break;
	case 2 :
	  samp->mode_3_0^=1;
	  redraw_8_16_bits(i, samp);
	  break;
      }
      break;
    case XK_Down :
      sample_exit_subwin_0_3(i, samp);
      samp->cur_pos_0_3++;
      if (samp->cur_pos_0_3>2)
	samp->cur_pos_0_3=0;
      sample_enter_subwin_0_3(i, samp);
      break;
    case XK_Up :
      sample_exit_subwin_0_3(i, samp);
      samp->cur_pos_0_3--;
      if (samp->cur_pos_0_3<0)
	samp->cur_pos_0_3=2;
      sample_enter_subwin_0_3(i, samp);
      break;
  }
}

void sample_subwin_0_4(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      if (!(samp->sample_type&3))
	samp->sample_type|=samp->cur_pos_0_4+1;
      else {
	int dum=(samp->sample_type&3)^3;
	samp->sample_type&=~3;
	if (dum==samp->cur_pos_0_4+1)
	  samp->sample_type|=dum;
      }
      redraw_use_loop(i, samp);
      redraw_sample(i, samp);
      break;
    case XK_Down :
    case XK_Up :
      sample_exit_subwin_0_4(i, samp);
      samp->cur_pos_0_4^=1;
      sample_enter_subwin_0_4(i, samp);
      break;
  }
}

void sample_subwin_0_5(INTERFACE *i, sample *samp, KeySym ks)
{
  /* nothing */
}

void sample_subwin_0_6(INTERFACE *i, sample *samp, KeySym ks)
{
  /* nothing */
}

void sample_subwin_0_7(INTERFACE *i, sample *samp, KeySym ks)
{
  /* nothing */
}

void sample_subwin_1_0(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(samp->cur_pos_1_0) {
	case 0 : { /* mixing rate ++ */
	  int inc=1;
	  if (samp->record_rate==44100) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    inc=10;
	  if (status==ControlMask)
	    inc=100;
	  if (status==(ShiftMask|ControlMask))
	    inc=1000;
	  if (status==Mod1Mask)
	    inc=10000;
	  samp->record_rate+=inc;
	  if (samp->record_rate>44100)
	    samp->record_rate=44100;
	  redraw_record_mixing_rate(i, samp);
	  break;
	}
	case 1 : { /* mixing rate -- */
	  int dec=1;
	  if (samp->record_rate==8000) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=10;
	  if (status==ControlMask)
	    dec=100;
	  if (status==(ShiftMask|ControlMask))
	    dec=1000;
	  if (status==Mod1Mask)
	    dec=10000;
	  samp->record_rate-=dec;
	  if (samp->record_rate<8000)
	    samp->record_rate=8000;
	  redraw_record_mixing_rate(i, samp);
	  break;
	}
	case 2 :
	case 3 :
	  if (samp->record_16b==samp->cur_pos_1_0-2) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  samp->record_16b=samp->cur_pos_1_0-2;
	  redraw_record_8_16_bits(i, samp);
	  break;
      }
      break;
    case XK_Down :
      sample_exit_subwin_1_0(i, samp);
      samp->cur_pos_1_0++;
      samp->cur_pos_1_0&=3;
      sample_enter_subwin_1_0(i, samp);
      break;
    case XK_Up :
      sample_exit_subwin_1_0(i, samp);
      samp->cur_pos_1_0--;
      samp->cur_pos_1_0&=3;
      sample_enter_subwin_1_0(i, samp);
      break;
  }
}

void sample_subwin_1_1(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(samp->cur_pos_1_1) {
	case 0 :
	  if (samp->record_frag_size==17) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  samp->record_frag_size++;
	  redraw_record_fragment_size(i, samp);
	  break;
	case 1 :
	  if (samp->record_frag_size==7) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  samp->record_frag_size--;
	  redraw_record_fragment_size(i, samp);
	  break;
	case 2 : {
	  int inc=1;
	  if (samp->record_nb_frags==255) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    inc=10;
	  if (status==ControlMask)
	    inc=100;
	  samp->record_nb_frags+=inc;
	  if (samp->record_nb_frags>255)
	    samp->record_nb_frags=255;
	  redraw_record_nb_fragments(i, samp);
	  break;
	}
	case 3 : {
	  int dec=1;
	  if (samp->record_nb_frags==2) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=10;
	  if (status==ControlMask)
	    dec=100;
	  samp->record_nb_frags-=dec;
	  if (samp->record_nb_frags<2)
	    samp->record_nb_frags=2;
	  redraw_record_nb_fragments(i, samp);
	  break;
	}
      }
      break;
    case XK_Down :
      sample_exit_subwin_1_1(i, samp);
      samp->cur_pos_1_1++;
      samp->cur_pos_1_1&=3;
      sample_enter_subwin_1_1(i, samp);
      break;
    case XK_Up :
      sample_exit_subwin_1_1(i, samp);
      samp->cur_pos_1_1--;
      samp->cur_pos_1_1&=3;
      sample_enter_subwin_1_1(i, samp);
      break;
  }
}

void sample_subwin_1_2(INTERFACE *i, sample *samp, KeySym ks)
{
  /* fuck off ! */
}

void sample_subwin_1_3(INTERFACE *i, sample *samp, KeySym ks)
{
  switch(ks) {
    case XK_Return :
    case XK_space :
      switch(samp->cur_pos_1_3) {
	case 0 : {
	  int inc=1;
	  if (samp->record_input_volume==100) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    inc=10;
	  if (status==ControlMask)
	    inc=100;
	  samp->record_input_volume+=inc;
	  if (samp->record_input_volume>100)
	    samp->record_input_volume=100;
	  redraw_record_input_volume(i, samp);
	  break;
	}
	case 1 : {
	  int dec=1;
	  if (samp->record_input_volume==0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  if (status==ShiftMask)
	    dec=10;
	  if (status==ControlMask)
	    dec=100;
	  samp->record_input_volume-=dec;
	  if (samp->record_input_volume<0)
	    samp->record_input_volume=0;
	  redraw_record_input_volume(i, samp);
	  break;
	}
      }
      break;
    case XK_Down :
    case XK_Up :
      sample_exit_subwin_1_3(i, samp);
      samp->cur_pos_1_3^=1;
      sample_enter_subwin_1_3(i, samp);
      break;
  }
}

void sample_subwin_1_4(INTERFACE *i, sample *samp, KeySym ks)
{
  fprintf(stderr, "hello\n");
  if (ks==XK_Escape || ks==XK_Return || ks==XK_space)
    i->in_record=0;
}

void (*sample_subwin[3][16])(INTERFACE *, sample *, KeySym)={
  {sample_subwin_0, sample_subwin_1, sample_subwin_2, sample_subwin_3,
   sample_subwin_4, sample_subwin_5, sample_subwin_6, sample_subwin_7,
   sample_subwin_0_0, sample_subwin_0_1, sample_subwin_0_2, sample_subwin_0_3,
   sample_subwin_0_4, sample_subwin_0_5, sample_subwin_0_6, sample_subwin_0_7},
  {sample_subwin_0, sample_subwin_1, sample_subwin_2, sample_subwin_3,
   sample_subwin_4, sample_subwin_5, sample_subwin_6, sample_subwin_7,
   sample_subwin_1_0, sample_subwin_1_1, sample_subwin_1_2, sample_subwin_1_3,
   sample_subwin_1_4},
  {sample_subwin_0, sample_subwin_1, sample_subwin_2, sample_subwin_3,
   sample_subwin_4, sample_subwin_5, sample_subwin_6, sample_subwin_7}
};
