/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august 1998.
 * This is total free software.
 *-------------------------------------
 * definition of a channel (had to put it in a new file because xm.h and mixer.h use it and they would include
 * each other if it would have stayed in mixer.h
 */

#ifndef _CHANNELS_DEF_H_
#define _CHANNELS_DEF_H_

#include "xm.h"

/* the channel structure */
typedef struct {
  instrument *instrument;
  sample *sample;
  unsigned long long sample_position;
  unsigned long long increment;
  char in_use;
  int left_volume, right_volume; /* 0..64 */
  int volume_point;
  int panning_point;
  int envelop_volume;
  int envelop_panning;
  int volume;
  int panning;
  int cut_key;
  char closed;	/* put to 1 if the mixer has not to take care of it
		 * (when you put it to 1, don't forget to put in_use to 0)
		 */
} channel;

#endif /* _CHANNELS_DEF_H_ */
